Package: catdata
Type: Package
Title: Categorical Data
Version: 1.2.4
Date: 2024-01-23
Encoding: UTF-8
Depends: MASS
Suggests: knitr, rms, qvcalc, glmmML, nnet, pscl, VGAM, gee, mlogit,
        Ecdat, geepack, mgcv, rpart, party, ordinal, lme4, vcdExtra,
        glmnet, mboost, class, e1071, flexmix, lpSolve, penalized
Author: Gunther Schauberger, Gerhard Tutz
Maintainer: Gunther Schauberger <gunther.schauberger@tum.de>
Description: This R-package contains examples from the book "Regression for Categorical Data", Tutz 2012, Cambridge University Press. The names of the examples refer to the chapter and the data set that is used. 
License: GPL-2
LazyLoad: yes
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2024-01-25 11:52:07 UTC; ge29weh
Repository: CRAN
Date/Publication: 2024-01-25 13:50:05 UTC
Built: R 4.3.3; ; 2025-01-24 05:20:59 UTC; unix

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  options(width=80)

## ----eval=FALSE---------------------------------------------------------------
#  library(catdata)
#  data(unemployment,package="catdata")

## ----fig.width=9,eval=FALSE---------------------------------------------------
#  library(party)
#  tree1<-ctree(as.factor(durbin)~age,data=unemployment)
#  
#  plot(tree1)

## ----eval=FALSE---------------------------------------------------------------
#  unemployment$durbin[unemployment$durbin==2]<-0
#  year<- unemployment$age
#  year [unemployment$age<29.5] <- 1
#  year [unemployment$age>29.5 & unemployment$age<52.5] <- 2
#  year [unemployment$age>52.5] <- 3
#   	
#  pre3 <- mean(unemployment$durbin[year==3])
#  pre2 <- mean(unemployment$durbin[year==2])
#  pre1 <- mean(unemployment$durbin[year==1])
#  
#  meanyear <- c()
#  
#  for (i in min(unemployment$age):max(unemployment$age)){
#  meanyear[i] <- sum(unemployment$durbin[unemployment$age==i])
#  if(sum(unemployment$durbin[unemployment$age==i])!=0){
#  meanyear[i] <- mean(unemployment$durbin[unemployment$age==i])
#  }
#  }
#  
#  unemployment$means<- rep(2, nrow(unemployment))
#  
#   for (k in 1:nrow(unemployment)){
#   unemployment$means[k] <- meanyear[unemployment$age[k]]
#   }

## ----fig.width=9,eval=FALSE---------------------------------------------------
#    plot(unemployment$age, unemployment$means, xlab="age",ylab="",cex.axis=1.5,
#         cex.lab=1.5)
#   segments(x0=min(unemployment$age),x1=29.5,y0=pre1)
#   segments(x0=29.5,x1=29.5,y0=pre1,y1=pre2)
#   segments(x0=29.5,x1=52.5,y0=pre2)
#   segments(x0=52.5,x1=52.5,y0=pre2,y1=pre3)
#   segments(x0=52.5,x1=max(unemployment$age),y0=pre3)

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
#  detach(package:party)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----eval=FALSE---------------------------------------------------------------
# library(catdata)
# data(unemployment,package="catdata")

## ----fig.width=9,eval=FALSE---------------------------------------------------
# library(party)
# tree1<-ctree(as.factor(durbin)~age,data=unemployment)
# 
# plot(tree1)

## ----eval=FALSE---------------------------------------------------------------
# unemployment$durbin[unemployment$durbin==2]<-0
# year<- unemployment$age
# year [unemployment$age<29.5] <- 1
# year [unemployment$age>29.5 & unemployment$age<52.5] <- 2
# year [unemployment$age>52.5] <- 3
#  	
# pre3 <- mean(unemployment$durbin[year==3])
# pre2 <- mean(unemployment$durbin[year==2])
# pre1 <- mean(unemployment$durbin[year==1])
# 
# meanyear <- c()
# 
# for (i in min(unemployment$age):max(unemployment$age)){
# meanyear[i] <- sum(unemployment$durbin[unemployment$age==i])
# if(sum(unemployment$durbin[unemployment$age==i])!=0){
# meanyear[i] <- mean(unemployment$durbin[unemployment$age==i])
# }
# }
# 
# unemployment$means<- rep(2, nrow(unemployment))
# 
#  for (k in 1:nrow(unemployment)){
#  unemployment$means[k] <- meanyear[unemployment$age[k]]
#  }

## ----fig.width=9,eval=FALSE---------------------------------------------------
#   plot(unemployment$age, unemployment$means, xlab="age",ylab="",cex.axis=1.5,
#        cex.lab=1.5)
#  segments(x0=min(unemployment$age),x1=29.5,y0=pre1)
#  segments(x0=29.5,x1=29.5,y0=pre1,y1=pre2)
#  segments(x0=29.5,x1=52.5,y0=pre2)
#  segments(x0=52.5,x1=52.5,y0=pre2,y1=pre3)
#  segments(x0=52.5,x1=max(unemployment$age),y0=pre3)

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# detach(package:party)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  options(width=80)

## ----eval=FALSE---------------------------------------------------------------
#  library(mlogit)

## ----eval=FALSE---------------------------------------------------------------
#  data(ModeChoice, package="Ecdat")

## ----eval=FALSE---------------------------------------------------------------
#  travel.long <- mlogit.data(ModeChoice, choice="mode", shape="long", alt.levels=
#  c("air","train","bus","car"))

## ----eval=FALSE---------------------------------------------------------------
#  travel.kat.id <- mlogit(mode ~ invt + gc|hinc, data=travel.long)
#  summary(travel.kat.id)

## ----eval=FALSE---------------------------------------------------------------
#  library(VGAM)

## ----eval=FALSE---------------------------------------------------------------
#  travelmode <- matrix(ModeChoice$mode, byrow = T, ncol = 4)
#  colnames(travelmode) <- c("air","train","bus","car")
#  travelhinc <- matrix(ModeChoice$hinc, byrow = T, ncol = 4)
#  travelhinc <- travelhinc[,1]
#  travelinvt <- matrix(ModeChoice$invt, byrow = T, ncol = 4)
#  colnames(travelinvt) <- c("invtair","invttrain","invtbus","invtcar")
#  travelgc <- matrix(ModeChoice$gc, byrow = T, ncol = 4)
#  colnames(travelgc) <- c("gcair","gctrain","gcbus","gccar")
#  
#  travelinvt <- sweep(travelinvt[,-1], 1, travelinvt[,1])
#  travelgc <- sweep(travelgc[,-1], 1, travelgc[,1])
#  
#  
#  Invt <- travelinvt[,1]
#  Gc <- travelgc[,1]
#  
#  traveldat <- cbind(travelhinc, travelinvt, Invt, travelgc, Gc)
#  traveldat <- as.data.frame(traveldat)

## ----eval=FALSE---------------------------------------------------------------
#  fit <- vglm(travelmode ~ Invt + Gc + travelhinc,
#              multinomial(parallel = FALSE ~ travelhinc, refLevel = 1),
#              xij = list(Invt ~ invttrain + invtbus + invtcar,
#                         Gc ~ gctrain + gcbus + gccar),
#              form2 = ~ Invt + invttrain + invtbus + invtcar +
#                        Gc + gctrain + gcbus + gccar + travelhinc,
#              data = traveldat, trace = TRUE)
#  
#  summary(fit)
#  summary(travel.kat.id)

## ----eval=FALSE---------------------------------------------------------------
#  summary(travel.kat.id)$CoefTable
#  summary(fit)@coef3

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
#  detach(package:VGAM)
#  detach(package:mlogit)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----eval=FALSE---------------------------------------------------------------
# library(mlogit)

## ----eval=FALSE---------------------------------------------------------------
# data(ModeChoice, package="Ecdat")

## ----eval=FALSE---------------------------------------------------------------
# travel.long <- mlogit.data(ModeChoice, choice="mode", shape="long", alt.levels=
# c("air","train","bus","car"))

## ----eval=FALSE---------------------------------------------------------------
# travel.kat.id <- mlogit(mode ~ invt + gc|hinc, data=travel.long)
# summary(travel.kat.id)

## ----eval=FALSE---------------------------------------------------------------
# library(VGAM)

## ----eval=FALSE---------------------------------------------------------------
# travelmode <- matrix(ModeChoice$mode, byrow = T, ncol = 4)
# colnames(travelmode) <- c("air","train","bus","car")
# travelhinc <- matrix(ModeChoice$hinc, byrow = T, ncol = 4)
# travelhinc <- travelhinc[,1]
# travelinvt <- matrix(ModeChoice$invt, byrow = T, ncol = 4)
# colnames(travelinvt) <- c("invtair","invttrain","invtbus","invtcar")
# travelgc <- matrix(ModeChoice$gc, byrow = T, ncol = 4)
# colnames(travelgc) <- c("gcair","gctrain","gcbus","gccar")
# 
# travelinvt <- sweep(travelinvt[,-1], 1, travelinvt[,1])
# travelgc <- sweep(travelgc[,-1], 1, travelgc[,1])
# 
# 
# Invt <- travelinvt[,1]
# Gc <- travelgc[,1]
# 
# traveldat <- cbind(travelhinc, travelinvt, Invt, travelgc, Gc)
# traveldat <- as.data.frame(traveldat)

## ----eval=FALSE---------------------------------------------------------------
# fit <- vglm(travelmode ~ Invt + Gc + travelhinc,
#             multinomial(parallel = FALSE ~ travelhinc, refLevel = 1),
#             xij = list(Invt ~ invttrain + invtbus + invtcar,
#                        Gc ~ gctrain + gcbus + gccar),
#             form2 = ~ Invt + invttrain + invtbus + invtcar +
#                       Gc + gctrain + gcbus + gccar + travelhinc,
#             data = traveldat, trace = TRUE)
# 
# summary(fit)
# summary(travel.kat.id)

## ----eval=FALSE---------------------------------------------------------------
# summary(travel.kat.id)$CoefTable
# summary(fit)@coef3

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# detach(package:VGAM)
# detach(package:mlogit)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  options(width=85)

## ----eval=FALSE---------------------------------------------------------------
#  unemployment <- matrix(c(97, 216, 56, 34, 105, 91, 31, 11,
#                    45, 81, 32, 9, 51, 81, 34, 9), nrow=8, ncol=2)
#  rownames(unemployment) <- c(paste("male", 1:4), paste("female", 1:4))
#  colnames(unemployment) <- c("Short term","Long term")
#  unemployment

## ----eval=FALSE---------------------------------------------------------------
#  y <- c(rep(1, sum(97, 216, 56, 34, 105, 91, 31, 11)),
#         rep(0, sum(45, 81, 32, 9, 51, 81, 34, 9)))
#  
#  G <- c(rep(1, sum(97, 216, 56, 34)), rep(0, sum(105, 91, 31, 11)),
#         rep(1, sum(45, 81, 32, 9)), rep(0, sum(51, 81, 34, 9)))
#  
#  L <- factor(c(rep(1, 97), rep(2, 216), rep(3, 56), rep(4, 34),
#         rep(1, 105), rep(2, 91), rep(3, 31), rep(4, 11),
#         rep(1, 45), rep(2, 81), rep(3, 32), rep(4, 9),
#         rep(1, 51), rep(2, 81), rep(3, 34), rep(4, 9)))
#  
#  table(G,L,y)

## ----eval=FALSE---------------------------------------------------------------
#  unemp_1 <- glm(y ~ 1,family=binomial)
#  unemp_G <- glm(y ~ G,family=binomial)
#  unemp_L <- glm(y ~ L,family=binomial)
#  unemp_LG <- glm(y ~ G + L,family=binomial)
#  unemp_sat <- glm(y ~ G * L,family=binomial)
#  summary(unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
#  anova(unemp_LG, unemp_sat)
#  anova(unemp_L, unemp_LG)
#  anova(unemp_1, unemp_L)
#  
#  anova(unemp_LG, unemp_sat)
#  anova(unemp_G, unemp_LG)
#  anova(unemp_1, unemp_G)

## ----eval=FALSE---------------------------------------------------------------
#  anova(unemp_1, unemp_sat)
#  anova(unemp_L, unemp_sat)
#  anova(unemp_G, unemp_sat)
#  anova(unemp_LG, unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
#  genderleveldat<-data.frame("Long term"=unemployment[,1],
#  "Short term"=unemployment[,2],"Level"=rep(1:4,2),"Gender"=rep(c(1,0),each=4))
#  
#  groupintercept<-glm(cbind(Long.term, Short.term) ~ 1, family=binomial,
#                      data=genderleveldat)
#  summary(groupintercept)
#  
#  #Corresponding un-grouped model:
#  summary(unemp_1)
#  
#  groupgender<-glm(cbind(Long.term, Short.term) ~ Gender, family=binomial,
#                   data=genderleveldat)
#  summary(groupgender)
#  
#  #Corresponding un-grouped model:
#  summary(unemp_G)
#  
#  
#  grouplevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Level), family=binomial,
#                  data=genderleveldat)
#  summary(grouplevel)
#  
#  #Corresponding un-grouped model:
#  summary(unemp_L)
#  
#  
#  groupgenderlevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) +
#    as.factor(Level), family=binomial, data=genderleveldat)
#  summary(groupgenderlevel)
#  
#  #Corresponding un-grouped model:
#  summary(unemp_LG)
#  
#  groupsat<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) * as.factor(Level),
#                family=binomial, data=genderleveldat)
#  summary(groupsat)
#  
#  #Corresponding un-grouped model:
#  summary(unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
#  anova(groupgenderlevel, groupsat)
#  anova(grouplevel, groupgenderlevel)
#  anova(groupintercept, grouplevel)
#  
#  
#  anova(groupgenderlevel, groupsat)
#  anova(groupgender, groupgenderlevel)
#  anova(groupintercept, groupgender)

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
#  rm(unemployment)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=85)

## ----eval=FALSE---------------------------------------------------------------
# unemployment <- matrix(c(97, 216, 56, 34, 105, 91, 31, 11,
#                   45, 81, 32, 9, 51, 81, 34, 9), nrow=8, ncol=2)
# rownames(unemployment) <- c(paste("male", 1:4), paste("female", 1:4))
# colnames(unemployment) <- c("Short term","Long term")
# unemployment

## ----eval=FALSE---------------------------------------------------------------
# y <- c(rep(1, sum(97, 216, 56, 34, 105, 91, 31, 11)),
#        rep(0, sum(45, 81, 32, 9, 51, 81, 34, 9)))
# 
# G <- c(rep(1, sum(97, 216, 56, 34)), rep(0, sum(105, 91, 31, 11)),
#        rep(1, sum(45, 81, 32, 9)), rep(0, sum(51, 81, 34, 9)))
# 
# L <- factor(c(rep(1, 97), rep(2, 216), rep(3, 56), rep(4, 34),
#        rep(1, 105), rep(2, 91), rep(3, 31), rep(4, 11),
#        rep(1, 45), rep(2, 81), rep(3, 32), rep(4, 9),
#        rep(1, 51), rep(2, 81), rep(3, 34), rep(4, 9)))
# 
# table(G,L,y)

## ----eval=FALSE---------------------------------------------------------------
# unemp_1 <- glm(y ~ 1,family=binomial)
# unemp_G <- glm(y ~ G,family=binomial)
# unemp_L <- glm(y ~ L,family=binomial)
# unemp_LG <- glm(y ~ G + L,family=binomial)
# unemp_sat <- glm(y ~ G * L,family=binomial)
# summary(unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
# anova(unemp_LG, unemp_sat)
# anova(unemp_L, unemp_LG)
# anova(unemp_1, unemp_L)
# 
# anova(unemp_LG, unemp_sat)
# anova(unemp_G, unemp_LG)
# anova(unemp_1, unemp_G)

## ----eval=FALSE---------------------------------------------------------------
# anova(unemp_1, unemp_sat)
# anova(unemp_L, unemp_sat)
# anova(unemp_G, unemp_sat)
# anova(unemp_LG, unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
# genderleveldat<-data.frame("Long term"=unemployment[,1],
# "Short term"=unemployment[,2],"Level"=rep(1:4,2),"Gender"=rep(c(1,0),each=4))
# 
# groupintercept<-glm(cbind(Long.term, Short.term) ~ 1, family=binomial,
#                     data=genderleveldat)
# summary(groupintercept)
# 
# #Corresponding un-grouped model:
# summary(unemp_1)
# 
# groupgender<-glm(cbind(Long.term, Short.term) ~ Gender, family=binomial,
#                  data=genderleveldat)
# summary(groupgender)
# 
# #Corresponding un-grouped model:
# summary(unemp_G)
# 
# 
# grouplevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Level), family=binomial,
#                 data=genderleveldat)
# summary(grouplevel)
# 
# #Corresponding un-grouped model:
# summary(unemp_L)
# 
# 
# groupgenderlevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) +
#   as.factor(Level), family=binomial, data=genderleveldat)
# summary(groupgenderlevel)
# 
# #Corresponding un-grouped model:
# summary(unemp_LG)
# 
# groupsat<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) * as.factor(Level),
#               family=binomial, data=genderleveldat)
# summary(groupsat)
# 
# #Corresponding un-grouped model:
# summary(unemp_sat)

## ----eval=FALSE---------------------------------------------------------------
# anova(groupgenderlevel, groupsat)
# anova(grouplevel, groupgenderlevel)
# anova(groupintercept, grouplevel)
# 
# 
# anova(groupgenderlevel, groupsat)
# anova(groupgender, groupgenderlevel)
# anova(groupintercept, groupgender)

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# rm(unemployment)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  options(width=80)

## ----eval=FALSE---------------------------------------------------------------
#  library(catdata)
#  data(medcare)
#  
#  library(MASS)
#  library(pscl)

## ----eval=FALSE---------------------------------------------------------------
#  medmale <- medcare[medcare$male==1,]
#  medmale <-medmale[medmale$ofp<=30,]

## ----eval=FALSE---------------------------------------------------------------
#  set.seed(5)
#  
#  subs<-1:nrow(medmale)
#  
#  reps <- 50
#  
#  squerror1<-squerror3<-squerror4<-squerror5<-squerror6<-squerror7<-c()
#  abserror1<-abserror3<-abserror4<-abserror5<-abserror6<-abserror7<-c()
#  
#  
#  for(i in 1:reps){
#  learn <- sample(subs,600)
#  test <- subs[-learn]
#  
#  ###########################
#  med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#          family=poisson,data=medmale[learn,])
#  l <- predict(med, newdata=medmale[test,], type="response")
#  
#  a<-rep(0,length(medmale[test,1]))
#  
#  for(j in 1:length(medmale[test,1])){
#  while(ppois(a[j],lambda=l[j])<0.5){
#  a[j] <- a[j] + 1
#  }
#  }
#  diffs <- a - medmale[test,1]
#  squerror1[i]<-mean(diffs^2)
#  abserror1[i]<-mean(abs(diffs))
#  
#  ######################
#  med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#              data=medmale[learn,])
#  l <- predict(med3, newdata=medmale[test,], type="response")
#  a<-rep(0,length(medmale[test,1]))
#  
#  for(j in 1:length(medmale[test,1])){
#  
#  while((pnbinom(a[j],mu=l[j],size=med3$theta))<0.5){
#  a[j] <- a[j]+1
#  }
#  }
#  
#  diffs <- a - medmale[test,1]
#  squerror3[i]<-mean(diffs^2)
#  abserror3[i]<-mean(abs(diffs))
#  
#  ##################
#  med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#                data=medmale[learn,])
#  pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
#  mui <- predict(med4, newdata=medmale[test,], type="count")
#  a<-rep(0,length(medmale[test,1]))
#  
#  for(j in 1:length(medmale[test,1])){
#  cdis <- 0
#  
#  while(cdis<0.5){
#  
#  cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
#    I(a[j]==0)
#  a[j] <- a[j]+1
#  }
#  a[j]<-a[j] - 1
#  }
#  diffs <- a - medmale[test,1]
#  squerror4[i]<-mean(diffs^2)
#  abserror4[i]<-mean(abs(diffs))
#  
#  ################################
#  med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#                data=medmale[learn,])
#  
#  pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
#  mui <- predict(med5, newdata=medmale[test,], type="count")
#  a<-rep(0,length(medmale[test,1]))
#  
#  for(j in 1:length(medmale[test,1])){
#  cdis <- 0
#  
#  while(cdis<0.5){
#  
#  cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
#    I(a[j]==0)
#  a[j] <- a[j]+1
#  }
#  a[j]<-a[j] - 1
#  }
#  
#  diffs <- a - medmale[test,1]
#  
#  squerror5[i]<-mean(diffs^2)
#  abserror5[i]<-mean(abs(diffs))
#  
#  ####################
#  med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#              data=medmale[learn,])
#  mui <- predict(med6, newdata=medmale[test,], type="count")
#  gammai <- predict(med6, newdata=medmale[test,], type="zero")
#  pii2<-1-gammai*(1-exp(-mui))
#  
#  
#  fa<-function(z,a){
#  ((z^a)/factorial(a))*exp(-z) }
#  
#  a<-rep(0,length(medmale[test,1]))
#  
#  for(j in 1:length(medmale[test,1])){
#  cdis <- pii2[j]
#  
#  if(cdis<0.5){
#  while(cdis<0.5){
#  #while((1-cumdist)>eps){
#  cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
#  a[j]<-a[j]+1
#  #a <- a+1
#  }
#  }
#  else{a[j]<-0}
#  }
#  
#  diffs <- a - medmale[test,1]
#  
#  squerror6[i]<-mean(diffs^2)
#  abserror6[i]<-mean(abs(diffs))
#  
#  #######################
#  med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#              data=medmale[learn,])
#  mui <- predict(med7, newdata=medmale[test,], type="count")
#  gammai <- predict(med7, newdata=medmale[test,], type="zero")
#  pii2<-1-gammai*(1-exp(-mui))
#  
#  fa<-function(z,a){
#  ((z^a)/factorial(a))*exp(-z) }
#  
#  a<-rep(0,length(medmale[test,1]))
#  
#  for(j in 1:length(medmale[test,1])){
#  cdis <- pii2[j]
#  
#  if(cdis<0.5){
#  while(cdis<0.5){
#  #while((1-cumdist)>eps){
#  cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
#  a[j]<-a[j]+1
#  }
#  }
#  else{a[j]<-0}
#  }
#  
#  diffs <- a - medmale[test,1]
#  
#  squerror7[i]<-mean(diffs^2)
#  abserror7[i]<-mean(abs(diffs))
#  
#  }

## ----fig.width=12,eval=FALSE--------------------------------------------------
#  par(mgp=c(0,3,0))
#  boxplot(abserror1,abserror3,abserror4,abserror5,abserror6,abserror7,
#  names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
#          "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)

## ----eval=FALSE---------------------------------------------------------------
#  library(catdata)
#  data(medcare)
#  #attach(medcare)
#  
#  library(MASS)
#  library(pscl)
#  
#  medmale <- medcare[medcare$male==1,]
#  medmale <-medmale[medmale$ofp<=30,]
#  set.seed(5)
#  
#  subs<-1:nrow(medmale)
#  
#  reps <- 50
#  
#  eps <- 1e-5
#  
#  lrps <- lrps3 <- lrps4 <- lrps5 <- lrps6 <- lrps7 <- rep(0,reps)
#  
#  for(i in 1:reps){
#  learn <- sample(subs,600)
#  test <- subs[-learn]
#  
#  
#  med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#          family=poisson,data=medmale[learn,])
#  
#  l <- predict(med, newdata=medmale[test,], type="response")
#  
#  
#  for(j in 1:length(medmale[test,1])){
#  for(a in 0:100){
#  #while((1-ppois(a,lambda=l[j]))>eps){
#  lrps[i] <- lrps[i] + (ppois(a,lambda=l[j]) - I(medmale[test,1][j] <= a))^2
#  #a <- a+1
#  }
#  }
#  
#  
#  med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#              data=medmale[learn,])
#  l <- predict(med3, newdata=medmale[test,], type="response")
#  
#  for(j in 1:length(medmale[test,1])){
#  #a <- 0
#  for (a in 0:100){
#  #while((1-pnbinom(a,mu=l[j],size=med3$theta))>eps){
#  lrps3[i] <- lrps3[i] + (pnbinom(a,mu=l[j],size=med3$theta) -
#    I(medmale[test,1][j] <= a))^2
#  #a <- a+1
#  }
#  }
#  
#  
#  med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#                data=medmale[learn,])
#  pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
#  mui <- predict(med4, newdata=medmale[test,], type="count")
#  
#  
#  for(j in 1:length(medmale[test,1])){
#  a <- 0
#  cumdist<-(1-pii[j])
#  #cumdist <- 0
#  for (a in 0:100){
#  #while((1-cumdist)>eps){
#  cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
#  lrps4[i] <- lrps4[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
#  #a <- a+1
#  }
#  }
#  
#  
#  med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#                data=medmale[learn,])
#  pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
#  mui <- predict(med5, newdata=medmale[test,], type="count")
#  
#  for(j in 1:length(medmale[test,1])){
#  a <- 0
#  cumdist<-(1-pii[j])
#  #cumdist <- 0
#  for (a in 0:100){
#  #while((1-cumdist)>eps){
#  cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
#  lrps5[i] <- lrps5[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
#  #a <- a+1
#  }
#  }
#  
#  
#  med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#              data=medmale[learn,])
#  mui <- predict(med6, newdata=medmale[test,], type="count")
#  gammai <- predict(med6, newdata=medmale[test,], type="zero")
#  pii2<-1-gammai*(1-exp(-mui))
#  
#  #rr<-coef(med6,model="zero")
#  
#  #pii<-exp(rr)/(1+exp(rr))
#  
#  #ga<-(1-pii)/(1-exp(-mui))
#  
#  fa<-function(z,a){
#  ((z^a)/factorial(a))*exp(-z) }
#  
#  for(j in 1:length(medmale[test,1])){
#  cumdist <- pii2[j]
#  
#  for(a in 1:100){
#  #while((1-cumdist)>eps){
#  cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
#  lrps6[i] <- lrps6[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
#  
#  #a <- a+1
#  }
#  }
#  
#  
#  
#  med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#              data=medmale[learn,])
#  mui <- predict(med7, newdata=medmale[test,], type="count")
#  gammai <- predict(med7, newdata=medmale[test,], type="zero")
#  pii2<-1-gammai*(1-exp(-mui))
#  
#  fa<-function(z,a){
#  ((z^a)/factorial(a))*exp(-z) }
#  
#  for(j in 1:length(medmale[test,1])){
#  cumdist <- pii2[j]
#  
#  for(a in 1:100){
#  #while((1-cumdist)>eps){
#  cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
#  lrps7[i] <- lrps7[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
#  
#  #a <- a+1
#  }
#  }
#  
#  }
#  
#  
#  lrps <-lrps/length(medmale[test,1])
#  lrps3 <-lrps3/length(medmale[test,1])
#  lrps4 <-lrps4/length(medmale[test,1])
#  lrps5 <-lrps5/length(medmale[test,1])
#  lrps6 <-lrps6/length(medmale[test,1])
#  lrps7 <-lrps7/length(medmale[test,1])

## ----fig.width=12,eval=FALSE--------------------------------------------------
#  par(mgp=c(0,3,0))
#  boxplot(lrps,lrps3,lrps4,lrps5,lrps6,lrps7,
#  names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
#          "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)
#  

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
#  detach(package:pscl)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----eval=FALSE---------------------------------------------------------------
# library(catdata)
# data(medcare)
# 
# library(MASS)
# library(pscl)

## ----eval=FALSE---------------------------------------------------------------
# medmale <- medcare[medcare$male==1,]
# medmale <-medmale[medmale$ofp<=30,]

## ----eval=FALSE---------------------------------------------------------------
# set.seed(5)
# 
# subs<-1:nrow(medmale)
# 
# reps <- 50
# 
# squerror1<-squerror3<-squerror4<-squerror5<-squerror6<-squerror7<-c()
# abserror1<-abserror3<-abserror4<-abserror5<-abserror6<-abserror7<-c()
# 
# 
# for(i in 1:reps){
# learn <- sample(subs,600)
# test <- subs[-learn]
# 
# ###########################
# med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#         family=poisson,data=medmale[learn,])
# l <- predict(med, newdata=medmale[test,], type="response")
# 
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# while(ppois(a[j],lambda=l[j])<0.5){
# a[j] <- a[j] + 1
# }
# }
# diffs <- a - medmale[test,1]
# squerror1[i]<-mean(diffs^2)
# abserror1[i]<-mean(abs(diffs))
# 
# ######################
# med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# l <- predict(med3, newdata=medmale[test,], type="response")
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# 
# while((pnbinom(a[j],mu=l[j],size=med3$theta))<0.5){
# a[j] <- a[j]+1
# }
# }
# 
# diffs <- a - medmale[test,1]
# squerror3[i]<-mean(diffs^2)
# abserror3[i]<-mean(abs(diffs))
# 
# ##################
# med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#               data=medmale[learn,])
# pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
# mui <- predict(med4, newdata=medmale[test,], type="count")
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- 0
# 
# while(cdis<0.5){
# 
# cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
#   I(a[j]==0)
# a[j] <- a[j]+1
# }
# a[j]<-a[j] - 1
# }
# diffs <- a - medmale[test,1]
# squerror4[i]<-mean(diffs^2)
# abserror4[i]<-mean(abs(diffs))
# 
# ################################
# med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#               data=medmale[learn,])
# 
# pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
# mui <- predict(med5, newdata=medmale[test,], type="count")
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- 0
# 
# while(cdis<0.5){
# 
# cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
#   I(a[j]==0)
# a[j] <- a[j]+1
# }
# a[j]<-a[j] - 1
# }
# 
# diffs <- a - medmale[test,1]
# 
# squerror5[i]<-mean(diffs^2)
# abserror5[i]<-mean(abs(diffs))
# 
# ####################
# med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#             data=medmale[learn,])
# mui <- predict(med6, newdata=medmale[test,], type="count")
# gammai <- predict(med6, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- pii2[j]
# 
# if(cdis<0.5){
# while(cdis<0.5){
# #while((1-cumdist)>eps){
# cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
# a[j]<-a[j]+1
# #a <- a+1
# }
# }
# else{a[j]<-0}
# }
# 
# diffs <- a - medmale[test,1]
# 
# squerror6[i]<-mean(diffs^2)
# abserror6[i]<-mean(abs(diffs))
# 
# #######################
# med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# mui <- predict(med7, newdata=medmale[test,], type="count")
# gammai <- predict(med7, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# a<-rep(0,length(medmale[test,1]))
# 
# for(j in 1:length(medmale[test,1])){
# cdis <- pii2[j]
# 
# if(cdis<0.5){
# while(cdis<0.5){
# #while((1-cumdist)>eps){
# cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
# a[j]<-a[j]+1
# }
# }
# else{a[j]<-0}
# }
# 
# diffs <- a - medmale[test,1]
# 
# squerror7[i]<-mean(diffs^2)
# abserror7[i]<-mean(abs(diffs))
# 
# }

## ----fig.width=12,eval=FALSE--------------------------------------------------
# par(mgp=c(0,3,0))
# boxplot(abserror1,abserror3,abserror4,abserror5,abserror6,abserror7,
# names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
#         "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)

## ----eval=FALSE---------------------------------------------------------------
# library(catdata)
# data(medcare)
# #attach(medcare)
# 
# library(MASS)
# library(pscl)
# 
# medmale <- medcare[medcare$male==1,]
# medmale <-medmale[medmale$ofp<=30,]
# set.seed(5)
# 
# subs<-1:nrow(medmale)
# 
# reps <- 50
# 
# eps <- 1e-5
# 
# lrps <- lrps3 <- lrps4 <- lrps5 <- lrps6 <- lrps7 <- rep(0,reps)
# 
# for(i in 1:reps){
# learn <- sample(subs,600)
# test <- subs[-learn]
# 
# 
# med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#         family=poisson,data=medmale[learn,])
# 
# l <- predict(med, newdata=medmale[test,], type="response")
# 
# 
# for(j in 1:length(medmale[test,1])){
# for(a in 0:100){
# #while((1-ppois(a,lambda=l[j]))>eps){
# lrps[i] <- lrps[i] + (ppois(a,lambda=l[j]) - I(medmale[test,1][j] <= a))^2
# #a <- a+1
# }
# }
# 
# 
# med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# l <- predict(med3, newdata=medmale[test,], type="response")
# 
# for(j in 1:length(medmale[test,1])){
# #a <- 0
# for (a in 0:100){
# #while((1-pnbinom(a,mu=l[j],size=med3$theta))>eps){
# lrps3[i] <- lrps3[i] + (pnbinom(a,mu=l[j],size=med3$theta) -
#   I(medmale[test,1][j] <= a))^2
# #a <- a+1
# }
# }
# 
# 
# med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#               data=medmale[learn,])
# pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
# mui <- predict(med4, newdata=medmale[test,], type="count")
# 
# 
# for(j in 1:length(medmale[test,1])){
# a <- 0
# cumdist<-(1-pii[j])
# #cumdist <- 0
# for (a in 0:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
# lrps4[i] <- lrps4[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# #a <- a+1
# }
# }
# 
# 
# med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#               data=medmale[learn,])
# pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
# mui <- predict(med5, newdata=medmale[test,], type="count")
# 
# for(j in 1:length(medmale[test,1])){
# a <- 0
# cumdist<-(1-pii[j])
# #cumdist <- 0
# for (a in 0:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
# lrps5[i] <- lrps5[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# #a <- a+1
# }
# }
# 
# 
# med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
#             data=medmale[learn,])
# mui <- predict(med6, newdata=medmale[test,], type="count")
# gammai <- predict(med6, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# #rr<-coef(med6,model="zero")
# 
# #pii<-exp(rr)/(1+exp(rr))
# 
# #ga<-(1-pii)/(1-exp(-mui))
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# for(j in 1:length(medmale[test,1])){
# cumdist <- pii2[j]
# 
# for(a in 1:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
# lrps6[i] <- lrps6[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# 
# #a <- a+1
# }
# }
# 
# 
# 
# med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
#             data=medmale[learn,])
# mui <- predict(med7, newdata=medmale[test,], type="count")
# gammai <- predict(med7, newdata=medmale[test,], type="zero")
# pii2<-1-gammai*(1-exp(-mui))
# 
# fa<-function(z,a){
# ((z^a)/factorial(a))*exp(-z) }
# 
# for(j in 1:length(medmale[test,1])){
# cumdist <- pii2[j]
# 
# for(a in 1:100){
# #while((1-cumdist)>eps){
# cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
# lrps7[i] <- lrps7[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
# 
# #a <- a+1
# }
# }
# 
# }
# 
# 
# lrps <-lrps/length(medmale[test,1])
# lrps3 <-lrps3/length(medmale[test,1])
# lrps4 <-lrps4/length(medmale[test,1])
# lrps5 <-lrps5/length(medmale[test,1])
# lrps6 <-lrps6/length(medmale[test,1])
# lrps7 <-lrps7/length(medmale[test,1])

## ----fig.width=12,eval=FALSE--------------------------------------------------
# par(mgp=c(0,3,0))
# boxplot(lrps,lrps3,lrps4,lrps5,lrps6,lrps7,
# names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
#         "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)
# 

## ----echo=FALSE,results='hide',eval=FALSE-------------------------------------
# detach(package:pscl)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  options(width=80)

## ----results='hide',eval=FALSE------------------------------------------------
#  library(catdata)
#  data(birth)
#  attach(birth)

## ----eval=FALSE---------------------------------------------------------------
#  intensive <- rep(0,length(Intensive))
#  intensive[Intensive>0] <- 1
#  Intensive <- intensive
#  
#  previous <- Previous
#  previous[previous>1] <- 2
#  Previous <- previous

## ----eval=FALSE---------------------------------------------------------------
#  library(gee)

## ----eval=FALSE---------------------------------------------------------------
#  library(VGAM)
#  Birth <- as.data.frame(na.omit(cbind(Intensive, Cesarean, Sex, Weight, Previous,
#  AgeMother)))
#  detach(birth)
#  bivarlogit <- vglm(cbind(Intensive , Cesarean) ~ Weight + AgeMother +
#  as.factor(Sex) + as.factor(Previous), binom2.or(zero=NULL), data=Birth)
#  summary(bivarlogit)

## ----eval=FALSE---------------------------------------------------------------
#  n <- dim(Birth)[1]
#  ID <- rep(1:n,2)
#  
#  InterceptInt <- InterceptCes <- rep(1, 2*n)
#  InterceptInt[(n+1):(2*n)] <- InterceptCes[1:n] <- 0
#  
#  AgeMotherInt <- AgeMotherCes <- rep(Birth$AgeMother,2)
#  AgeMotherInt[(n+1):(2*n)] <- AgeMotherCes[1:n] <- 0
#  
#  SexInt <- SexCes <- rep(Birth$Sex,2)
#  SexInt[SexInt==1] <- SexCes[SexCes==1] <- 0
#  SexInt[SexInt==2] <- SexCes[SexCes==2] <- 1
#  SexInt[(n+1):(2*n)] <- SexCes[1:n] <- 0
#  
#  PrevBase <- rep(Birth$Previous,2)
#  PreviousInt1 <- PreviousCes1 <- PreviousInt2 <- PreviousCes2 <- rep(0, 2*n)
#  PreviousInt1[PrevBase==1] <- PreviousCes1[PrevBase==1] <- 1
#  PreviousInt2[PrevBase>=2] <- PreviousCes2[PrevBase>=2] <- 1
#  PreviousInt1[(n+1):(2*n)] <- PreviousInt2[(n+1):(2*n)] <- PreviousCes1[1:n] <-
#    PreviousCes2[1:n] <- 0
#  
#  WeightInt <- WeightCes <- rep(Birth$Weight,2)
#  WeightInt[(n+1):(2*n)] <- WeightCes[1:n] <- 0

## ----eval=FALSE---------------------------------------------------------------
#  GeeDat <- as.data.frame(cbind(ID, InterceptInt, InterceptCes, SexInt , SexCes ,
#  WeightInt , WeightCes , PreviousInt1 , PreviousInt2, PreviousCes1,
#  PreviousCes2, AgeMotherInt , AgeMotherCes, Response=
#  c(Birth$Intensive, Birth$Cesarean)))

## ----eval=FALSE---------------------------------------------------------------
#  gee1 <- gee (Response ~ -1 + InterceptInt + InterceptCes + WeightInt + WeightCes
#               + AgeMotherInt + AgeMotherCes + SexInt + SexCes +
#  PreviousInt1 + PreviousCes1 + PreviousInt2 + PreviousCes2,
#  family=binomial(link=logit), id=ID, data=GeeDat)
#  
#  summary(gee1)

## ----eval=FALSE---------------------------------------------------------------
#  coefficients(bivarlogit)[1:2]
#  coefficients(gee1)[1:2]
#  
#  coefficients(bivarlogit)[4:5]
#  coefficients(gee1)[3:4]
#  
#  coefficients(bivarlogit)[7:8]
#  coefficients(gee1)[5:6]
#  
#  coefficients(bivarlogit)[10:11]
#  coefficients(gee1)[7:8]
#  
#  coefficients(bivarlogit)[13:14]
#  coefficients(gee1)[9:10]
#  
#  coefficients(bivarlogit)[16:17]
#  coefficients(gee1)[11:12]

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  detach(package:VGAM)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=80)

## ----results='hide',eval=FALSE------------------------------------------------
# library(catdata)
# data(birth)
# attach(birth)

## ----eval=FALSE---------------------------------------------------------------
# intensive <- rep(0,length(Intensive))
# intensive[Intensive>0] <- 1
# Intensive <- intensive
# 
# previous <- Previous
# previous[previous>1] <- 2
# Previous <- previous

## ----eval=FALSE---------------------------------------------------------------
# library(gee)

## ----eval=FALSE---------------------------------------------------------------
# library(VGAM)
# Birth <- as.data.frame(na.omit(cbind(Intensive, Cesarean, Sex, Weight, Previous,
# AgeMother)))
# detach(birth)
# bivarlogit <- vglm(cbind(Intensive , Cesarean) ~ Weight + AgeMother +
# as.factor(Sex) + as.factor(Previous), binom2.or(zero=NULL), data=Birth)
# summary(bivarlogit)

## ----eval=FALSE---------------------------------------------------------------
# n <- dim(Birth)[1]
# ID <- rep(1:n,2)
# 
# InterceptInt <- InterceptCes <- rep(1, 2*n)
# InterceptInt[(n+1):(2*n)] <- InterceptCes[1:n] <- 0
# 
# AgeMotherInt <- AgeMotherCes <- rep(Birth$AgeMother,2)
# AgeMotherInt[(n+1):(2*n)] <- AgeMotherCes[1:n] <- 0
# 
# SexInt <- SexCes <- rep(Birth$Sex,2)
# SexInt[SexInt==1] <- SexCes[SexCes==1] <- 0
# SexInt[SexInt==2] <- SexCes[SexCes==2] <- 1
# SexInt[(n+1):(2*n)] <- SexCes[1:n] <- 0
# 
# PrevBase <- rep(Birth$Previous,2)
# PreviousInt1 <- PreviousCes1 <- PreviousInt2 <- PreviousCes2 <- rep(0, 2*n)
# PreviousInt1[PrevBase==1] <- PreviousCes1[PrevBase==1] <- 1
# PreviousInt2[PrevBase>=2] <- PreviousCes2[PrevBase>=2] <- 1
# PreviousInt1[(n+1):(2*n)] <- PreviousInt2[(n+1):(2*n)] <- PreviousCes1[1:n] <-
#   PreviousCes2[1:n] <- 0
# 
# WeightInt <- WeightCes <- rep(Birth$Weight,2)
# WeightInt[(n+1):(2*n)] <- WeightCes[1:n] <- 0

## ----eval=FALSE---------------------------------------------------------------
# GeeDat <- as.data.frame(cbind(ID, InterceptInt, InterceptCes, SexInt , SexCes ,
# WeightInt , WeightCes , PreviousInt1 , PreviousInt2, PreviousCes1,
# PreviousCes2, AgeMotherInt , AgeMotherCes, Response=
# c(Birth$Intensive, Birth$Cesarean)))

## ----eval=FALSE---------------------------------------------------------------
# gee1 <- gee (Response ~ -1 + InterceptInt + InterceptCes + WeightInt + WeightCes
#              + AgeMotherInt + AgeMotherCes + SexInt + SexCes +
# PreviousInt1 + PreviousCes1 + PreviousInt2 + PreviousCes2,
# family=binomial(link=logit), id=ID, data=GeeDat)
# 
# summary(gee1)

## ----eval=FALSE---------------------------------------------------------------
# coefficients(bivarlogit)[1:2]
# coefficients(gee1)[1:2]
# 
# coefficients(bivarlogit)[4:5]
# coefficients(gee1)[3:4]
# 
# coefficients(bivarlogit)[7:8]
# coefficients(gee1)[5:6]
# 
# coefficients(bivarlogit)[10:11]
# coefficients(gee1)[7:8]
# 
# coefficients(bivarlogit)[13:14]
# coefficients(gee1)[9:10]
# 
# coefficients(bivarlogit)[16:17]
# coefficients(gee1)[11:12]

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# detach(package:VGAM)

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  options(width=60)

## ----results='hide',eval=FALSE------------------------------------------------
#  library(catdata)
#  data(unemployment)
#  attach(unemployment)

## ----eval=FALSE---------------------------------------------------------------
#  durbin <- as.factor(durbin)
#  table.durbin <- ftable(subset(unemployment, select=c("age", "durbin")),
#  col.vars="durbin")
#  rels<-table.durbin[,1]/rowSums(table.durbin)
#  age.new <- min(age):max(age)
#  
#  model1 <- glm(table.durbin ~ age.new, family=binomial)
#  summary(model1)

## ----eval=FALSE---------------------------------------------------------------
#  plot(age.new, model1$fitted.values, xlab="Age", ylab="Observed/Fitted values",
#  type="l", ylim=c(0,1))
#  points(age.new,table.durbin[,1]/rowSums(table.durbin))

## ----eval=FALSE---------------------------------------------------------------
#  plot(model1$fitted.values,sqrt(rowSums(table.durbin))*rstandard(model1),
#  xlab="Predicted values", ylab="Residuals")

## ----eval=FALSE---------------------------------------------------------------
#  qqnorm(sqrt(rowSums(table.durbin))*rstandard(model1), main="",
#         ylab="Standardized deviance residuals")
#  qqline(sqrt(rowSums(table.durbin))*rstandard(model1), lwd=2.5,
#         lty="dashed", col="red")

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=60)

## ----results='hide',eval=FALSE------------------------------------------------
# library(catdata)
# data(unemployment)
# attach(unemployment)

## ----eval=FALSE---------------------------------------------------------------
# durbin <- as.factor(durbin)
# table.durbin <- ftable(subset(unemployment, select=c("age", "durbin")),
# col.vars="durbin")
# rels<-table.durbin[,1]/rowSums(table.durbin)
# age.new <- min(age):max(age)
# 
# model1 <- glm(table.durbin ~ age.new, family=binomial)
# summary(model1)

## ----eval=FALSE---------------------------------------------------------------
# plot(age.new, model1$fitted.values, xlab="Age", ylab="Observed/Fitted values",
# type="l", ylim=c(0,1))
# points(age.new,table.durbin[,1]/rowSums(table.durbin))

## ----eval=FALSE---------------------------------------------------------------
# plot(model1$fitted.values,sqrt(rowSums(table.durbin))*rstandard(model1),
# xlab="Predicted values", ylab="Residuals")

## ----eval=FALSE---------------------------------------------------------------
# qqnorm(sqrt(rowSums(table.durbin))*rstandard(model1), main="",
#        ylab="Standardized deviance residuals")
# qqline(sqrt(rowSums(table.durbin))*rstandard(model1), lwd=2.5,
#        lty="dashed", col="red")

## ----echo=FALSE,eval=FALSE----------------------------------------------------
#  options(width=85)

## ----results='hide',eval=FALSE------------------------------------------------
#  library(catdata)
#  data(addiction)
#  attach(addiction)

## ----eval=FALSE---------------------------------------------------------------
#  library(nnet)

## ----eval=FALSE---------------------------------------------------------------
#  ill <- as.factor(ill)
#  addiction$ill<-as.factor(addiction$ill)

## ----eval=FALSE---------------------------------------------------------------
#  multinom0 <- multinom(ill ~ gender + age + university, data=addiction)
#  summary(multinom0)

## ----eval=FALSE---------------------------------------------------------------
#  library(VGAM)
#  multivgam0<-vglm(ill ~ gender + age + university, multinomial(refLevel=1),
#                   data=addiction)
#  summary(multivgam0)

## ----eval=FALSE---------------------------------------------------------------
#  addiction$age2 <- addiction$age^2
#  multinom1 <- update(multinom0, . ~ . + age2)
#  summary(multinom1)
#  
#  multivgam1<-vglm(ill ~ gender + age + university + age2, multinomial(refLevel=1),
#                   data=addiction)
#  summary(multivgam1)

## ----eval=FALSE---------------------------------------------------------------
#  anova(multinom0,multinom1)
#  multinom1$dev - multinom0$dev

## ----eval=FALSE---------------------------------------------------------------
#  minage <- min(na.omit(age))
#  maxage <- max(na.omit(age))
#  
#  ageindex <- seq(minage, maxage, 0.1)
#  n <- length(ageindex)

## ----eval=FALSE---------------------------------------------------------------
#  ageindex2 <- ageindex^2
#  
#  gender1 <- rep(1, n)
#  gender0 <- rep(0, n)
#  university1 <- rep(1, n)
#  
#  datamale <- as.data.frame(cbind(gender=gender0,age=ageindex,university=
#    university1,age2=ageindex2))
#  datafemale <- as.data.frame(cbind(gender=gender1,age=ageindex,university=
#    university1,age2=ageindex2))

## ----eval=FALSE---------------------------------------------------------------
#  probsmale <- predict(multinom1, datamale, type="probs")
#  probsfemale <- predict(multinom1, datafemale, type="probs")

## ----echo=TRUE,eval=FALSE-----------------------------------------------------
#  par(cex=1.4, lwd=2)
#  
#  plot(ageindex, probsmale[,1], type="l", lty=1, ylim=c(0,1), main=
#  "men with university degree", ylab="probabilities")
#  lines(ageindex, probsmale[,2], lty="dotted")
#  lines(ageindex, probsmale[,3], lty="dashed")
#  legend("topright", legend=c("Weak-willed", "diseased", "both"), lty=c("solid",
#  "dotted", "dashed"))

## ----echo=TRUE,eval=FALSE-----------------------------------------------------
#  par(cex=1.4, lwd=2)
#  
#  plot(ageindex, probsfemale[,1], type="l", lty=1, ylim=c(0,1), main=
#    "women with university degree", ylab="probabilities")
#  lines(ageindex, probsfemale[,2], lty="dotted")
#  lines(ageindex, probsfemale[,3], lty="dashed")
#  legend("topright", legend=c("Weak-willed", "diseased", "both"),
#         lty=c("solid", "dotted", "dashed"))

## ----echo=FALSE,eval=FALSE----------------------------------------------------
# options(width=85)

## ----results='hide',eval=FALSE------------------------------------------------
# library(catdata)
# data(addiction)
# attach(addiction)

## ----eval=FALSE---------------------------------------------------------------
# library(nnet)

## ----eval=FALSE---------------------------------------------------------------
# ill <- as.factor(ill)
# addiction$ill<-as.factor(addiction$ill)

## ----eval=FALSE---------------------------------------------------------------
# multinom0 <- multinom(ill ~ gender + age + university, data=addiction)
# summary(multinom0)

## ----eval=FALSE---------------------------------------------------------------
# library(VGAM)
# multivgam0<-vglm(ill ~ gender + age + university, multinomial(refLevel=1),
#                  data=addiction)
# summary(multivgam0)

## ----eval=FALSE---------------------------------------------------------------
# addiction$age2 <- addiction$age^2
# multinom1 <- update(multinom0, . ~ . + age2)
# summary(multinom1)
# 
# multivgam1<-vglm(ill ~ gender + age + university + age2, multinomial(refLevel=1),
#                  data=addiction)
# summary(multivgam1)

## ----eval=FALSE---------------------------------------------------------------
# anova(multinom0,multinom1)
# multinom1$dev - multinom0$dev

## ----eval=FALSE---------------------------------------------------------------
# minage <- min(na.omit(age))
# maxage <- max(na.omit(age))
# 
# ageindex <- seq(minage, maxage, 0.1)
# n <- length(ageindex)

## ----eval=FALSE---------------------------------------------------------------
# ageindex2 <- ageindex^2
# 
# gender1 <- rep(1, n)
# gender0 <- rep(0, n)
# university1 <- rep(1, n)
# 
# datamale <- as.data.frame(cbind(gender=gender0,age=ageindex,university=
#   university1,age2=ageindex2))
# datafemale <- as.data.frame(cbind(gender=gender1,age=ageindex,university=
#   university1,age2=ageindex2))

## ----eval=FALSE---------------------------------------------------------------
# probsmale <- predict(multinom1, datamale, type="probs")
# probsfemale <- predict(multinom1, datafemale, type="probs")

## ----echo=TRUE,eval=FALSE-----------------------------------------------------
# par(cex=1.4, lwd=2)
# 
# plot(ageindex, probsmale[,1], type="l", lty=1, ylim=c(0,1), main=
# "men with university degree", ylab="probabilities")
# lines(ageindex, probsmale[,2], lty="dotted")
# lines(ageindex, probsmale[,3], lty="dashed")
# legend("topright", legend=c("Weak-willed", "diseased", "both"), lty=c("solid",
# "dotted", "dashed"))

## ----echo=TRUE,eval=FALSE-----------------------------------------------------
# par(cex=1.4, lwd=2)
# 
# plot(ageindex, probsfemale[,1], type="l", lty=1, ylim=c(0,1), main=
#   "women with university degree", ylab="probabilities")
# lines(ageindex, probsfemale[,2], lty="dotted")
# lines(ageindex, probsfemale[,3], lty="dashed")
# legend("topright", legend=c("Weak-willed", "diseased", "both"),
#        lty=c("solid", "dotted", "dashed"))

% \VignetteIndexEntry{Addiction - Additive Multinomial Logit Models}
% \VignetteDepends{mgcv}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Addiction - Additive Multinomial Logit Models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

First the "Addiction"--Data from "catdata" are loaded and attached.

<<results='hide',eval=FALSE>>=
library(catdata)
data(addiction)
attach(addiction)
@

For the fitting of GAMs  the library "mgcv" is used.

<<eval=FALSE>>=
library(mgcv)
@

Now we create two data frames that will be used to predict the probabilities along the range of age, the columns are "age", "gender" and "university". We 
create one data frame for women and one for men. 

<<eval=FALSE>>=
minage <- min(na.omit(age))
maxage <- max(na.omit(age))
ageindex <- seq(minage, maxage, 0.1)
n <- length(ageindex)
@

<<eval=FALSE>>=
gender1 <- rep(1, n)
gender0 <- rep(0, n)
university1 <- rep(1, n)
university0 <- rep(0, n)

datamale <- as.data.frame(cbind(gender=gender0,age=ageindex,university=university1))
datafemale <- as.data.frame(cbind(gender=gender1,age=ageindex,
                                  university=university1))
@

For the hierarchical model a new reponse "ill01" is created.

<<eval=FALSE>>=
ill01 <-ill
ill01[ill==1] <- 0
ill01[ill==2] <- 1
@

Now the two GAMs for the hierarchical model are fitted, "gam1" models category "0" and category "1" versus category "2", 
"gam2" models category "0" versus category "1".

<<eval=FALSE>>=
gam1 <- gam(as.factor(ill01) ~ s(age) + gender + university, family=binomial())
gam2 <- gam(as.factor(ill) ~ s(age) + gender + university, family=binomial(), 
            data=addiction[addiction$ill!=2,])
@

Then the corresponding summaries are printed.

<<eval=FALSE>>=
summary(gam1)
summary(gam2)
@

Now the smoothed effects for age are plotted.

<<fig.width=9,eval=FALSE>>=
plot(gam1)
@

<<fig.width=9,eval=FALSE>>=
plot(gam2)
@

For predicting the probabilities for the respective categories the probabilities from both GAMs are needed.
These can be computed by the "predict"--function. First we use the data frame for men for prediction.

<<eval=FALSE>>=
predmale1 <- predict(gam1, newdata=datamale, type="response")
predmale2 <- predict(gam2, newdata=datamale, type="response")
@

<<eval=FALSE>>=
predfemale1 <- predict(gam1, newdata=datafemale, type="response")
predfemale2 <- predict(gam2, newdata=datafemale, type="response")
@

Then we compute the probabilities for each category, first for men, afterwards for women.

<<eval=FALSE>>=
p2 <- predmale1
p1 <- predmale2 * (1-predmale1)
p0 <- (1-predmale2) * (1-predmale1)
@

<<eval=FALSE>>=
pf2 <- predfemale1
pf1 <- predfemale2 * (1-predfemale1)
pf0 <- (1-predfemale2) * (1-predfemale1)
@

Now finally the probabilities for the respective categories can be plotted.

<<fig.width=16, fig.height=8.5,eval=FALSE>>=
par(mfrow=c(1,2), cex=1.8)
plot(ageindex, p0, type="l", lty=1, ylim=c(0,1), main="men with university degree",
     ylab="probabilities")
lines(ageindex, p1, lty="dotted")
lines(ageindex, p2, lty="dashed")
legend("topright", legend=c("Weak-willed", "diseased", "both"), 
       lty=c("solid", "dotted", "dashed"))


plot(ageindex, pf0, type="l", lty=1, ylim=c(0,1), 
     main="women with university degree", ylab="probabilities")
lines(ageindex, pf1, lty="dotted")
lines(ageindex, pf2, lty="dashed")
legend("topright", legend=c("Weak-willed", "diseased", "both"),
       lty=c("solid", "dotted", "dashed"))
@

The models "gam3" and "gam4" compare category 0 versus 1 and category 0 versus 2 respectively. 

<<eval=FALSE>>=
gam3 <- gam(as.factor(ill)~ s(age) + gender + university, 
            data=addiction[addiction$ill!=2,], family=binomial())
gam4 <- gam(as.factor(ill)~ s(age) + gender + university, 
            data=addiction[addiction$ill!=1,], family=binomial())
@


<<eval=FALSE>>=
summary(gam3)
summary(gam4)
@

\end{document}

% \VignetteIndexEntry{Medical Care - Zero-Inflated and Zero-Hurdle-Model}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Medical Care - Zero-Inflated and Zero-Hurdle-Model}

\begin{document}

\maketitle
First  the medcare data are loaded:
<<results='hide',eval=TRUE>>=
library(catdata)
data(medcare)
attach(medcare)
@

The dependent variable "ofp" (numbers of physician visits) is a count variable, so a poisson-family glm seems to be a good choice.
<<eval=TRUE>>=
med1=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
         family=poisson,data=medcare[male==1 & ofp<=30,])
summary(med1)
@
In many real-world datasets the variance of count-data is higher than predicted by the Poisson distribution, so we fit a quasi-Poisson model with dispersion parameter.
<<eval=TRUE>>=
med2=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
         family=quasipoisson,data=medcare[male==1 & ofp<=30,])
summary(med2)
@
With an estimated dispersion parameter of 4.69 the standard errors are much bigger now.
An alternative to a quasi-poisson model is to use the negative binomial distribution.
<<eval=TRUE>>=
library(MASS)
med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
            data=medcare[male==1 & ofp<=30,])
summary(med3)
@
In this model the standard errors are slightly lower with the result that "healthexcellent" and "married" are now significant. (level=0.05)
<<eval=TRUE>>=
@
In count data there are often much more zeros than expected. Therefore one can fit a "zero-inflated" model using the pscl package. In the first "zero-inflated" model one assumes that the occurence of zeros does depend on covariates:
<<results='hide',eval=TRUE>>=
library(pscl)
@
<<eval=TRUE>>=
med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
              data=medcare[male==1 & ofp<=30,])
summary(med4)
@
In the second "zero-inflated" model  the occurence of zeros can depend on covariates:
<<eval=TRUE>>=
med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
              data=medcare[male==1 & ofp<=30,])
summary(med5)
@
An alternative to "zero-inflation" is the "zero-hurdle" model. In the following similar models as above are fitted.
<<eval=TRUE>>=
med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1
            ,data=medcare[male==1 & ofp<=30,])
summary(med6)
@
<<eval=TRUE>>=
med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
            data=medcare[male==1 & ofp<=30,])
summary(med7)
@
\end{document}

% \VignetteIndexEntry{Birth Data - Bivariate Binary GEE}
% \VignetteDepends{VGAM, gee}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Birth Data - Bivariate Binary GEE}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

The Birth data are loaded.

<<results='hide',eval=FALSE>>=
library(catdata)
data(birth)
attach(birth)
@

The original variable "Intensive" is converted into the binary variable "Intensive" indicating 
whether the child spent time in intensive care or not. In addition, "Previous" is reduced to 3 
categories by merging two and more previous pregnancies to level "2".

<<eval=FALSE>>=
intensive <- rep(0,length(Intensive))
intensive[Intensive>0] <- 1
Intensive <- intensive

previous <- Previous
previous[previous>1] <- 2
Previous <- previous
@

For the GEE the package "gee" will be used.

<<eval=FALSE>>=
library(gee)
@

For comparison again the binary regression model "bivarlogit" including odds ratios is fitted

<<eval=FALSE>>=
library(VGAM)
Birth <- as.data.frame(na.omit(cbind(Intensive, Cesarean, Sex, Weight, Previous, 
AgeMother)))
detach(birth)
bivarlogit <- vglm(cbind(Intensive , Cesarean) ~ Weight + AgeMother + 
as.factor(Sex) + as.factor(Previous), binom2.or(zero=NULL), data=Birth)
summary(bivarlogit)
@

To fit the bivariate GEE the covariates have to be created separately for both response variables.

<<eval=FALSE>>=
n <- dim(Birth)[1]
ID <- rep(1:n,2)

InterceptInt <- InterceptCes <- rep(1, 2*n)
InterceptInt[(n+1):(2*n)] <- InterceptCes[1:n] <- 0

AgeMotherInt <- AgeMotherCes <- rep(Birth$AgeMother,2)
AgeMotherInt[(n+1):(2*n)] <- AgeMotherCes[1:n] <- 0

SexInt <- SexCes <- rep(Birth$Sex,2)
SexInt[SexInt==1] <- SexCes[SexCes==1] <- 0
SexInt[SexInt==2] <- SexCes[SexCes==2] <- 1
SexInt[(n+1):(2*n)] <- SexCes[1:n] <- 0

PrevBase <- rep(Birth$Previous,2)
PreviousInt1 <- PreviousCes1 <- PreviousInt2 <- PreviousCes2 <- rep(0, 2*n)
PreviousInt1[PrevBase==1] <- PreviousCes1[PrevBase==1] <- 1
PreviousInt2[PrevBase>=2] <- PreviousCes2[PrevBase>=2] <- 1
PreviousInt1[(n+1):(2*n)] <- PreviousInt2[(n+1):(2*n)] <- PreviousCes1[1:n] <- 
  PreviousCes2[1:n] <- 0

WeightInt <- WeightCes <- rep(Birth$Weight,2)
WeightInt[(n+1):(2*n)] <- WeightCes[1:n] <- 0
@

The created covariates are collected in the data set "GeeDat" that will be used for the GEE.

<<eval=FALSE>>=
GeeDat <- as.data.frame(cbind(ID, InterceptInt, InterceptCes, SexInt , SexCes , 
WeightInt , WeightCes , PreviousInt1 , PreviousInt2, PreviousCes1, 
PreviousCes2, AgeMotherInt , AgeMotherCes, Response=
c(Birth$Intensive, Birth$Cesarean)))
@

Finally the GEE is fitted.

<<eval=FALSE>>=
gee1 <- gee (Response ~ -1 + InterceptInt + InterceptCes + WeightInt + WeightCes 
             + AgeMotherInt + AgeMotherCes + SexInt + SexCes +
PreviousInt1 + PreviousCes1 + PreviousInt2 + PreviousCes2,
family=binomial(link=logit), id=ID, data=GeeDat)

summary(gee1)
@

Here the respective coefficients from the bivariate regression model and from the GEE can be compared.

<<eval=FALSE>>=
coefficients(bivarlogit)[1:2]
coefficients(gee1)[1:2]

coefficients(bivarlogit)[4:5]
coefficients(gee1)[3:4]

coefficients(bivarlogit)[7:8]
coefficients(gee1)[5:6]

coefficients(bivarlogit)[10:11]
coefficients(gee1)[7:8]

coefficients(bivarlogit)[13:14]
coefficients(gee1)[9:10]

coefficients(bivarlogit)[16:17]
coefficients(gee1)[11:12]
@

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Travel Mode - Multinomial Logit Model}
% \VignetteDepends{mlogit, Ecdat}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Travel Mode - Multinomial Logit Model}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

For multinomial models that include category--specific as well as global effects the
function "mlogit" from the library "mlogit" can be used.

<<eval=FALSE>>=
library(mlogit)
@

The  "Travel Mode"--data are stored in the "Edcat"--package and can be loaded by the following
command.

<<eval=FALSE>>=
data(ModeChoice, package="Ecdat")
@

For the use of the function "mlogit"  an appropriate data set has to be built. This is done by  use of
the function "mlogit.data". 

<<eval=FALSE>>=
travel.long <- mlogit.data(ModeChoice, choice="mode", shape="long", alt.levels=
c("air","train","bus","car"))
@

Now  the model can be fitted. In the formula first the category--specific effects and then, 
separated by "|", the global effects are specified.

<<eval=FALSE>>=
travel.kat.id <- mlogit(mode ~ invt + gc|hinc, data=travel.long)
summary(travel.kat.id)
@

Now the same model is fitted with the package "VGAM".

<<eval=FALSE>>=
library(VGAM)
@

At first the data need to be prepared adequately to be ready for use with the function "vglm".

<<eval=FALSE>>=
travelmode <- matrix(ModeChoice$mode, byrow = T, ncol = 4)
colnames(travelmode) <- c("air","train","bus","car")
travelhinc <- matrix(ModeChoice$hinc, byrow = T, ncol = 4)
travelhinc <- travelhinc[,1]
travelinvt <- matrix(ModeChoice$invt, byrow = T, ncol = 4)
colnames(travelinvt) <- c("invtair","invttrain","invtbus","invtcar")
travelgc <- matrix(ModeChoice$gc, byrow = T, ncol = 4)
colnames(travelgc) <- c("gcair","gctrain","gcbus","gccar")

travelinvt <- sweep(travelinvt[,-1], 1, travelinvt[,1])
travelgc <- sweep(travelgc[,-1], 1, travelgc[,1])


Invt <- travelinvt[,1]
Gc <- travelgc[,1]

traveldat <- cbind(travelhinc, travelinvt, Invt, travelgc, Gc)
traveldat <- as.data.frame(traveldat)
@

Now the model can be fitted.

<<eval=FALSE>>=
fit <- vglm(travelmode ~ Invt + Gc + travelhinc,
            multinomial(parallel = FALSE ~ travelhinc, refLevel = 1),
            xij = list(Invt ~ invttrain + invtbus + invtcar,
                       Gc ~ gctrain + gcbus + gccar),
            form2 = ~ Invt + invttrain + invtbus + invtcar +
                      Gc + gctrain + gcbus + gccar + travelhinc,
            data = traveldat, trace = TRUE)

summary(fit)
summary(travel.kat.id)
@

At last we compare the coefficients of the two fitted models.

<<eval=FALSE>>=
summary(travel.kat.id)$CoefTable
summary(fit)@coef3
@

<<echo=FALSE,results='hide',eval=FALSE>>=
detach(package:VGAM)
detach(package:mlogit)
@

\end{document}

% \VignetteIndexEntry{Birth Data - Bivariate Binary Regression}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Birth Data - Bivariate Binary Regression}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@


First the Birth data are loaded from package "catdata".

<<results='hide',eval=FALSE>>=
library(catdata)
data(birth)
attach(birth)
@

Now  the original variable "Intensive" is converted into the binary variable "Intensive" indicating 
whether the child spent time in intensive care or not.

<<eval=FALSE>>=
intensive <- rep(0,length(Intensive))
intensive[Intensive>0] <- 1
Intensive <- intensive
@

Now "Previous" is reduced to 3 categories by merging two and more previous pregnancies to level "2".

<<eval=FALSE>>=
previous <- Previous
previous[previous>1] <- 2 
Previous <- previous
@

<<eval=FALSE>>=
library(VGAM)
@

The data set "Birth" is built as data set containing the variables for the model but without  missing values.

<<eval=FALSE>>=
Birth <- as.data.frame(na.omit(cbind(Intensive, Cesarean, Sex, Weight, Previous, 
AgeMother)))
detach(birth)
@

With that data set the model can be fitted. The option "binom2.or" is needed to fit a bivariate binary model. 

<<eval=FALSE>>=
bivarlogit <- vglm(cbind(Intensive , Cesarean) ~ as.factor(Sex) + Weight + 
as.factor(Previous) + AgeMother, binom2.or(zero=NULL), data=Birth)

summary(bivarlogit)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@

\end{document}

% \VignetteIndexEntry{Duration of Unemployment - Analysis of Deviance Table for Nested Models}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Duration of Unemployment - Analysis of Deviance Table for Nested Models}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=85)
@


The data unemployment is included as a contingency table. The response is the duration of unemployment, gender and the level of education are predictors.
<<eval=FALSE>>=
unemployment <- matrix(c(97, 216, 56, 34, 105, 91, 31, 11, 
                  45, 81, 32, 9, 51, 81, 34, 9), nrow=8, ncol=2)
rownames(unemployment) <- c(paste("male", 1:4), paste("female", 1:4))
colnames(unemployment) <- c("Short term","Long term")
unemployment
@
In the first part the data are considered as ungrouped. Thus, first the dataset is transformed into single observations on the variables y (duration of unemployment, binary), L (level of education) and G (gender).
<<eval=FALSE>>=
y <- c(rep(1, sum(97, 216, 56, 34, 105, 91, 31, 11)), 
       rep(0, sum(45, 81, 32, 9, 51, 81, 34, 9)))
       
G <- c(rep(1, sum(97, 216, 56, 34)), rep(0, sum(105, 91, 31, 11)),  
       rep(1, sum(45, 81, 32, 9)), rep(0, sum(51, 81, 34, 9)))
       
L <- factor(c(rep(1, 97), rep(2, 216), rep(3, 56), rep(4, 34),
       rep(1, 105), rep(2, 91), rep(3, 31), rep(4, 11),
       rep(1, 45), rep(2, 81), rep(3, 32), rep(4, 9),
       rep(1, 51), rep(2, 81), rep(3, 34), rep(4, 9)))
  
table(G,L,y)
@ 


Fitting of various logit models; in particular, the saturated model (model with both covariates and their interaction),
the model with main effects, the two models with only one covariate and the intercept model. 
Deviances are for ungrouped data

<<eval=FALSE>>=
unemp_1 <- glm(y ~ 1,family=binomial)
unemp_G <- glm(y ~ G,family=binomial)
unemp_L <- glm(y ~ L,family=binomial)
unemp_LG <- glm(y ~ G + L,family=binomial)
unemp_sat <- glm(y ~ G * L,family=binomial)
summary(unemp_sat)
@

Tests for hierarchies  and corresponding effects:
<<eval=FALSE>>=
anova(unemp_LG, unemp_sat)
anova(unemp_L, unemp_LG)
anova(unemp_1, unemp_L)

anova(unemp_LG, unemp_sat)
anova(unemp_G, unemp_LG)
anova(unemp_1, unemp_G)
@

Tests that can be used to obtain the deviances for the grouped data.  
<<eval=FALSE>>=
anova(unemp_1, unemp_sat) 
anova(unemp_L, unemp_sat)
anova(unemp_G, unemp_sat)
anova(unemp_LG, unemp_sat)
@ 


In the second part the model are fitted as grouped data, which directly yields the deviances for the  grouped data case.
The parameter estimates remain the same, but the deviances and the AIC differ from the ungrouped case.


<<eval=FALSE>>=
genderleveldat<-data.frame("Long term"=unemployment[,1],
"Short term"=unemployment[,2],"Level"=rep(1:4,2),"Gender"=rep(c(1,0),each=4))

groupintercept<-glm(cbind(Long.term, Short.term) ~ 1, family=binomial, 
                    data=genderleveldat)
summary(groupintercept)

#Corresponding un-grouped model:
summary(unemp_1)

groupgender<-glm(cbind(Long.term, Short.term) ~ Gender, family=binomial, 
                 data=genderleveldat)
summary(groupgender)

#Corresponding un-grouped model:
summary(unemp_G)


grouplevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Level), family=binomial, 
                data=genderleveldat)
summary(grouplevel)

#Corresponding un-grouped model:
summary(unemp_L)


groupgenderlevel<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) + 
  as.factor(Level), family=binomial, data=genderleveldat)
summary(groupgenderlevel)

#Corresponding un-grouped model:
summary(unemp_LG)

groupsat<-glm(cbind(Long.term, Short.term) ~ as.factor(Gender) * as.factor(Level), 
              family=binomial, data=genderleveldat)
summary(groupsat)

#Corresponding un-grouped model:
summary(unemp_sat)
@




ANOVA for grouped data:

<<eval=FALSE>>=
anova(groupgenderlevel, groupsat) 
anova(grouplevel, groupgenderlevel) 
anova(groupintercept, grouplevel)

 
anova(groupgenderlevel, groupsat) 
anova(groupgender, groupgenderlevel) 
anova(groupintercept, groupgender)
@ 


<<echo=FALSE,results='hide',eval=FALSE>>=
rm(unemployment)
@

\end{document}

% \VignetteIndexEntry{Exposure to Dust - Logistic Regression and Search for Outliers}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Exposure to Dust - Logistic Regression and Search for Outliers}

\begin{document}

\maketitle
First of all, the dust data are loaded:
<<results='hide',eval=FALSE>>=
library(catdata)
data(dust)
attach(dust)
@
First, the subsample of non-smokers is considered. A main effect logit model yields the following results:
<<eval=FALSE>>=
dustlogitnon1=glm(bronch ~ dust+years, family=binomial, data=dust[(dust$smoke==0),])
summary(dustlogitnon1)
@
The same model as above is used without observation 1245 which can be regarded as an outlier:
<<eval=FALSE>>=
dustlogitnon2 <- glm(bronch ~ dust+years, family=binomial, 
                     data=dust[(dust$smoke==0)&(dust$dust<10),])
summary(dustlogitnon2)
@

The following calculations are based on the complete dataset. Therefore, main effect logit models are fitted for all observations and without
observation 1246, respectively:
<<eval=FALSE>>=
dustlogit1 <- glm(bronch ~ dust+years+smoke, family=binomial, data=dust)
summary(dustlogit1)
@

<<eval=FALSE>>=
dustlogit2 <- glm(bronch ~ dust+years+smoke, family=binomial, 
                  data=dust[(dust$dust<20),])
summary(dustlogit2)
@

\end{document}

% \VignetteIndexEntry{Knee Injuries - Proportional Odds Models}
% \VignetteDepends{rms, MASS, VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Injuries - Proportional Odds Models}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=80)
@


At the beginning the knee dataset is loaded:

<<results='hide',eval=FALSE>>=
rm(list=ls(all=TRUE))
library(catdata)
data(knee)
attach(knee)
@

First of all a simple $\chi^{2}$ -- test of independence between the therapy (Th) and the pain level (R4) is applied.
<<eval=FALSE>>=
suppressWarnings(chisq.test(knee$Th,knee$R4))
@

In the following the variable Age is centered around $30$ years and the quadratic variable Age2 is created.
<<eval=FALSE>>=
Age <- Age - 30
Age2 <- Age^2
@

The response pain (R4) has to be an ordered factor, the covariates therapy (Th) and sex (Sex) need to be factors.
<<eval=FALSE>>=
R4 <- as.ordered(R4)
Th <- as.factor(Th)
Sex <- as.factor(Sex)
@

A proportional odds model can be fitted by the function "polr" from the "MASS" -- library. Attention has to be paid to the algebraic signs of the coefficients.
These are inverse to the usual interpretation in porportional odds models.
<<eval=FALSE>>=
library(MASS)
@

The first model only uses therapy as covariate, to achieve a proportional odds model the option "method" needs to use the logistic link function.

<<results='hide',eval=FALSE>>=
polr1 <- polr(R4 ~ Th, method="logistic")
@

<<eval=FALSE>>=
summary(polr1)
@

The corresponding odds--ratio can be recieved by the following command (consider the inverse sign!):
<<eval=FALSE>>=
exp(-coef(polr1))
@



Now a model with the covariates therapy, sex and age is fitted.
<<results='hide',eval=FALSE>>=
polr2 <- polr(R4 ~ Th + Sex + Age, method="logistic")
@

<<eval=FALSE>>=
summary(polr2)
@

Odds--ratios for the second model:
<<eval=FALSE>>=
exp(-coef(polr2))
@

To get the Wald--statistic, the standard errors have to be extracted from the summary.
Afterwards the Wald--statistic and the corresponding p--values are easily recieved.

<<eval=FALSE>>=
se <- summary(polr2)[1][[1]][1:3,2]
(wald2 <- -coef(polr2)/se)
@

P--values for the second model:
<<eval=FALSE>>=
1-pchisq(wald2^2, df=1)
@


Finally the quadratic age--effect is added to the previous model.
<<results='hide',eval=FALSE>>=
polr3 <- update(polr2, ~. + Age2)
@

<<eval=FALSE>>=
summary(polr3)
@

Odds--ratios for the final model:
<<eval=FALSE>>=
exp(-coef(polr3))
@

Wald--statistic for the final model:

<<eval=FALSE>>=
se <- summary(polr3)[1][[1]][1:4,2]
(wald3 <- -coef(polr3)/se)
@

P--values for the final model:
<<eval=FALSE>>=
1-pchisq(wald3^2, df=1)
@

As the proportional odds--model is the most popular model for ordinal data, there are several
different ways to fit such models. Now the final model is additionally fitted with function "vglm" 
from the "VGAM"--library and with function "lrm" from the "rms"--library.

\bigskip

Model fitted with "vglm":

<<eval=FALSE>>=
library(VGAM)
@

<<eval=FALSE>>=
m.vglm <- vglm(R4 ~ Th + Sex + Age + Age2, family = cumulative (link="logit", 
parallel=TRUE))
summary(m.vglm)
@

The resulting coefficients are very similar to the coefficients in the model above fitted
with function "polr", but they have inverse signs. Therefore they can be interpreted in the usual way.

\bigskip

Model fitted with "lrm":
<<eval=FALSE>>=
library(rms)
@

<<eval=FALSE>>=
m.lrm <- lrm(R4 ~ Th + Sex + Age + Age2)
m.lrm
@

Again no big differences are found concerning the coefficients. Here the signs are the same as with the function "polr".

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Foodstamp - Residuals of Logistic Regression}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Foodstamp - Residuals of Logistic Regression}

\begin{document}

\maketitle

Load and attach the data foodstamp.
<<results='hide',eval=FALSE>>=
library(catdata)
data(foodstamp)
attach(foodstamp)
@
With binary resonse one can fit a logit model.
<<eval=FALSE>>=
food1 <- glm(y ~ TEN + SUP + INC, family=binomial, data=foodstamp)
summary(food1)
@
Have a look at the distribution of the residuals. Therefore a Normal Q-Q Plot is generated.
<<eval=FALSE>>=
plot(food1,2)
@

\end{document}

% \VignetteIndexEntry{Addiction - Multinomial Model}
% \VignetteDepends{nnet}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Addiction - Multinomial Model}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=85)
@

First the "addiction" data are loaded and attached.

<<results='hide',eval=FALSE>>=
library(catdata)
data(addiction)
attach(addiction)
@

For the multinomial logit model the function "multinom" from the "nnet"--package is used.

<<eval=FALSE>>=
library(nnet)
@

The response "ill" has to be used as factor.

<<eval=FALSE>>=
ill <- as.factor(ill)
addiction$ill<-as.factor(addiction$ill)
@

The first model is a model with the covariates "gender", "university" and a linear effect of "age"

<<eval=FALSE>>=
multinom0 <- multinom(ill ~ gender + age + university, data=addiction)
summary(multinom0)
@

Another possibility to fit multinomial response models is given by the function "vglm" from the package "VGAM". 
<<eval=FALSE>>=
library(VGAM)
multivgam0<-vglm(ill ~ gender + age + university, multinomial(refLevel=1), 
                 data=addiction)
summary(multivgam0)
@
Both models yield the same parameter estimates. 
\\ \\
The second model includes an additional quadratic effect of "age".

<<eval=FALSE>>=
addiction$age2 <- addiction$age^2
multinom1 <- update(multinom0, . ~ . + age2)
summary(multinom1)

multivgam1<-vglm(ill ~ gender + age + university + age2, multinomial(refLevel=1), 
                 data=addiction)
summary(multivgam1)
@
It should be noted that the standard errors for the models generated by "nnet" and "VGAM" differ when age is included quadratically. The parameter estimates are equal again. 
\\ \\
Now the necessity of the quadratic term is tested by using the function "anova".

<<eval=FALSE>>=
anova(multinom0,multinom1)
multinom1$dev - multinom0$dev
@

Now we  plot the probabilities for the  responses against age. First a sequence within the range of age has to be created.

<<eval=FALSE>>=
minage <- min(na.omit(age))
maxage <- max(na.omit(age))

ageindex <- seq(minage, maxage, 0.1)
n <- length(ageindex)
@

Now the   vectors for the other covariates  and the  data sets for men and women 
are  built. 

<<eval=FALSE>>=
ageindex2 <- ageindex^2

gender1 <- rep(1, n)
gender0 <- rep(0, n)
university1 <- rep(1, n)

datamale <- as.data.frame(cbind(gender=gender0,age=ageindex,university=
  university1,age2=ageindex2)) 
datafemale <- as.data.frame(cbind(gender=gender1,age=ageindex,university=
  university1,age2=ageindex2))
@

Now for the built data sets the probabilities based on model "multinom1" are computed.

<<eval=FALSE>>=
probsmale <- predict(multinom1, datamale, type="probs")
probsfemale <- predict(multinom1, datafemale, type="probs")
@

Now the probabilities can be plotted.

<<echo=TRUE,eval=FALSE>>=
par(cex=1.4, lwd=2)

plot(ageindex, probsmale[,1], type="l", lty=1, ylim=c(0,1), main=
"men with university degree", ylab="probabilities")
lines(ageindex, probsmale[,2], lty="dotted") 
lines(ageindex, probsmale[,3], lty="dashed") 
legend("topright", legend=c("Weak-willed", "diseased", "both"), lty=c("solid", 
"dotted", "dashed"))
@

<<echo=TRUE,eval=FALSE>>=
par(cex=1.4, lwd=2)

plot(ageindex, probsfemale[,1], type="l", lty=1, ylim=c(0,1), main=
  "women with university degree", ylab="probabilities")
lines(ageindex, probsfemale[,2], lty="dotted")                                                  
lines(ageindex, probsfemale[,3], lty="dashed") 
legend("topright", legend=c("Weak-willed", "diseased", "both"), 
       lty=c("solid", "dotted", "dashed"))
@
\end{document}                            

% \VignetteIndexEntry{Duration of Unemployment - Cubic B-Splines}
% \VignetteDepends{mgcv}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Duration of Unemployment - Cubic B-Splines}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

The unemployment data from catdata are loaded.

<<eval=FALSE>>=
library(catdata)
data(unemployment, package="catdata")
attach(unemployment)
@

The GAM is fitted by using the library "mgcv".

<<eval=FALSE>>=
library(mgcv)
@

Now the response "durbin" is transformed and the GAM is fitted.

<<eval=FALSE>>=
durbin[durbin==2] <- 0

gamage <- gam(durbin ~ s(age, bs="ps", m=c(2,1), k=15), family=binomial())
@

To plot the fitted probabilities for the whole range of age probabilities have to be predicted.

<<eval=FALSE>>=
minage <- min(age)
maxage <- max(age)
ageindex <- seq(from=minage, to=maxage, by=0.01)

pred <- predict(gamage, newdata=data.frame("age"=ageindex), type="response")
@

The following function describes the code for B--Splines.

<<eval=FALSE>>=
bspline<-function(x,k,i,m=2)
{if (m==-1)
{res<-as.numeric(x<k[i+1]&x>=k[i])}
else{
z0<-(x-k[i])/(k[i+m+1]-k[i])
z1<-(k[i+m+2]-x)/(k[i+m+2]-k[i+1])
res<- z0*bspline(x,k,i,m-1)+z1*bspline(x,k,i+1,m-1)}
res}
@

Now the knots for the B--Splines are defined, furthermore for each age the corresponding mean of durbin is computed.

<<eval=FALSE>>=
k <- gamage$smooth[[1]]$knots

meanage <- c()

for (i in minage:maxage){
meanage[i] <- sum(durbin[age==i])
if(sum(durbin[age==i])!=0){
meanage[i] <- mean(durbin[age==i])
}
}
@

Now the line for the predicted probabilities, the B--Splines and the corresponding means for each age are plotted.

<<fig.width=8,eval=FALSE>>=
par(cex=1.3, lwd=1.5)
plot(ageindex, pred, type="l", ylim=c(0,0.8), col="gray", xlab="age/years", 
     ylab="short-term unemployment")
for(i in 1:15)
{lines(ageindex,(0.5*gamage$coefficients[i+1]+0.7)*(bspline(x=ageindex,k=k,
i=i+1,m=2)),type="l", col="gray")}
points(minage:maxage, meanage[minage:maxage], pch=20)
@

Via the option "fx=TRUE" a unpenalized gam is fitted, afterwards again the probabilities for the whole range of age are computed.

<<eval=FALSE>>=
gamage2 <- gam(durbin ~ s(age, bs="ps", fx=TRUE, m=c(2,1),k=15), family=binomial())

pred2 <- predict(gamage2, newdata=data.frame("age"=ageindex), type="response")
@

Now for the unpenalized GAM the new probabilities, the new B--Splines and again the means are plotted. The fitted line for the probabilities is very wiggly now.

<<fig.width=8,eval=FALSE>>=
par(cex=1.3, lwd=1.5)
plot(ageindex, pred2, type="l", ylim=c(0,0.8), col="gray", xlab="age/years", 
     ylab="short-term unemployment")
for(i in 1:15)
{lines(ageindex, (0.1*gamage2$coefficients[i+1]+0.3)*
  bspline(x=ageindex,k=k,i=i+1,m=2),type="l", col="gray")}
points(minage:maxage, meanage[minage:maxage],pch=20)
@

<<echo=FALSE,results='hide',eval=FALSE>>=
detach(unemployment)
rm(unemployment)
@
\end{document}

% \VignetteIndexEntry{Knee Data - Sequential/Cumulative Random Effects Logit Models}
% \VignetteDepends{MASS, lme4, ordinal}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Data - Sequential/Cumulative Random Effects Logit Models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

For the sequential and cumulative random effects logit models we use the knee data from "catdata". We load 
the data "kneesequential" and "kneecumulative" which are already transformed and ready for use in the sequential or 
cumulative model.

<<results='hide',eval=FALSE>>=
library(catdata)
data(kneesequential)
data(kneecumulative)
@

The covariate "Age" is centered around 30 years and a quadratic effect of "Age" is created for both data sets.

<<eval=FALSE>>=
kneesequential$Age <- kneesequential$Age - 30
kneesequential$Age2 <- kneesequential$Age^2

kneecumulative$Age <- kneecumulative$Age - 30
kneecumulative$Age2<-kneecumulative$Age^2
@

For the sequential random effects logit model with Gauss--Hermite--Quadrature the function "glmer" from "lme4" is used.

<<eval=FALSE>>=
library(lme4)
@

Now the sequential model with 25 quadrature points (option "nAGQ=25") and a random intercept is fitted.

<<eval=FALSE>>=
seqGH<-glmer(y~-1+Icept1+Icept2+Icept3+Icept4+Th+Age+Age2+(1|Person), 
             family=binomial(link=logit),data=kneesequential, nAGQ = 25)
summary(seqGH)
@

The sequential model with Penalized Quasi--Likelihood is fitted with the function "glmmPQL" from the "MASS" library.

<<eval=FALSE>>=
library(MASS)
@

Here the sequential model with Penalized Quasi--Likelihood is fitted.

<<eval=FALSE>>=
seqPQL<-glmmPQL(y ~-1+Icept1+Icept2+Icept3+Icept4+Th+Age+Age2, 
random=list(Person=~1), family=binomial(link=logit), data=kneesequential, niter=30)
summary(seqPQL)
@

The cumulative models will be fitted with "clmm" from the package "ordinal".

<<eval=FALSE>>=
library(ordinal)
@

For the sequential random effects logit model with Gauss--Hermite Quadrature the number of quadrature points is defined by the option "nAGQ=25". 
Now the model is fitted again with a random intercept as the only random effect.

<<eval=FALSE>>=
cumGH<-clmm2(as.factor(y)~1+Th+Age+Age2, random = as.factor(Person), data = 
kneecumulative, link = "logistic",nAGQ=25,start=c(-5,-3,3,5,rep(0.001,4)),Hess=TRUE)
summary(cumGH)
@

For Laplace--Approximation the option "nAGQ"  can be dropped.

<<eval=FALSE>>=
cumLP<-clmm2(as.factor(y)~1+Th+Age+Age2, random = as.factor(Person), data = 
kneecumulative, link = "logistic",start=c(-5,-3,3,5,rep(0.001,4)), Hess = TRUE)
summary(cumLP)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:ordinal)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:lme4)
@
\end{document}

% \VignetteIndexEntry{Arthritis - Cumulative Logit Model}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
    \documentclass[a4paper]{article}

\title{Arthritis - Cumulative Logit Model}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=80)
@


A simple data frame for the arthritis data is created with the numbers given for the individual cells.

<<eval=FALSE>>=
arthritis <- data.frame(drug=c(rep("new agent", 24+37+21+19+6), 
rep("active control", 11+51+22+21+7)), 
assessment=c(rep(1,24), rep(2,37), rep(3,21), rep(4,19), rep(5,6), rep(1,11), 
rep(2,51), rep(3,22), rep(4,21), rep(5,7)))
@

<<eval=FALSE>>=
library(VGAM)
@

Now a cumulative model is fitted.

<<eval=FALSE>>=
cumart <- vglm(assessment ~ drug, family=cumulative(parallel=TRUE, link="logit"), 
              data=arthritis)
@

<<eval=FALSE>>=
summary(cumart)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Knee Data - Discrete Mixture Model}
% \VignetteDepends{flexmix}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Data - Discrete Mixture Model}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

The "knee"--data from "catdata" are loaded.

<<eval=FALSE>>=
library(catdata)
data(knee)
@

The data set contains longitudinal data and is currently in the "wide" format,  now it is transformed into the  "long" format by the function "reshape". 

In addition the response is dichotomized, "age" is centered around 30 and a quadratic effect "age2" of age is created.

<<eval=FALSE>>=
knee <- reshape(knee, direction="long", varying=list(5:8), v.names="R",
                timevar="Time")

knee$RD <- rep(0, length(knee$R))
knee$RD[knee$R>2] <- 1

knee$Age <- knee$Age - 30
knee$Age2<-knee$Age^2
@

The covariates "Th" and "Sex" are factorized.

<<eval=FALSE>>=
knee$Th <- as.factor(knee$Th)
knee$Sex <- as.factor(knee$Sex)
@

For discrete mixture models  the library "flexmix" is used.

<<eval=FALSE>>=
library(flexmix)
@

Now some discrete mixture models are fitted, each with another number of components. Every model fits fixed effects for the covariates "Th", "Sex", "Age" and 
"Age2" while the intercepts vary across components. 

<<eval=FALSE>>=
kneeflex2 <-stepFlexmix(cbind(RD,1-RD) ~ 1 | N,	model = FLXMRglmfix(family = 
  "binomial", fixed= ~ Th + Sex + Age + Age2), k = 2, nrep = 5, data = knee)

kneeflex3 <-stepFlexmix(cbind(RD,1-RD) ~ 1 | N,	model = FLXMRglmfix(family = 
  "binomial", fixed= ~ Th + Sex + Age + Age2), k = 3, nrep = 5, data = knee)

kneeflex4 <-stepFlexmix(cbind(RD,1-RD) ~ 1 | N,	model = FLXMRglmfix(family = 
  "binomial", fixed= ~ Th + Sex + Age + Age2), k = 4, nrep = 5, data = knee)
@

We compare the fitted models by BIC.


<<eval=FALSE>>=
summary(kneeflex2)@BIC
summary(kneeflex3)@BIC
summary(kneeflex4)@BIC
@

As the model with two components has the lowest BIC, the coefficients of that model are printed.

<<eval=FALSE>>=
summary(refit(kneeflex2))
@

<<echo=FALSE,eval=FALSE>>=
detach(package:flexmix)
@

\end{document}

% \VignetteIndexEntry{Number of Children - Partially Additive Model}
% \VignetteDepends{mgcv}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Number of Children - Partially Additive Model}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

For the following partially additive model  the "children"--data from the package "catdata" are used. 

<<eval=FALSE>>=
library(catdata)
data(children)
@

Additive Models are  fitted with the function "gam" from "mgcv".

<<eval=FALSE>>=
library(mgcv)
@

Here the model is fitted and the summary is printed.

<<eval=FALSE>>=
gamchild <- gam(child ~ s(age) + s(dur) + as.factor(nation) + as.factor(god) + 
  as.factor(univ), data=children, family=poisson(link=log))

summary(gamchild)
@

Now the smooth effects can be plotted, the option "select" determines which effect is plotted.

<<fig.width=9,eval=FALSE>>=
par(cex=1.5)
plot(gamchild, select=1, ylab="", xlab="Age")
@

<<fig.width=9,eval=FALSE>>=
par(cex=1.5)
plot(gamchild, select=2, ylab="", xlab="Duration")
@


\end{document}

% \VignetteIndexEntry{Party Preference - Star Plots}
% \VignetteDepends{grDevices, nnet}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Party Preference - Star Plots}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

First the party preference data are built, then they are transformed to a data set that will be used for the multinomial response models. 
The data include party preference, age in four categories and gender. 

<<eval=FALSE>>=
partypref <- matrix(data=c(114, 10, 53, 224,134,9,42,226,114,8,23,174,339,30,13,
414,42,5,44,161,88,10,60,171,90,8,31,168, 413,23,14,375), nrow=8, byrow=TRUE)

partydat<-data.frame(
party=c(rep("CDU",sum(partypref[,1])),rep("SPD",sum(partypref[,4])),
rep("The Liberals",sum(partypref[,2])),rep("The Greens",sum(partypref[,3]))),
sex=c(rep(0,sum(partypref[1:4,1])),rep(1,sum(partypref[5:8,1])),
rep(0,sum(partypref[1:4,4])),rep(1,sum(partypref[5:8,4])),
rep(0,sum(partypref[1:4,2])),rep(1,sum(partypref[5:8,2])),
rep(0,sum(partypref[1:4,3])),rep(1,sum(partypref[5:8,3]))),
age=c(rep(c(1:4,1:4), partypref[,1]),rep(c(1:4,1:4), partypref[,4]),
rep(c(1:4,1:4), partypref[,2]),rep(c(1:4,1:4), partypref[,3])))
@

Now  star plots are to be built. For every subgroup of male/female and old/young (categories "1" and "4") a star will be plotted.

First the corresponding relative frequencies for the subgroups are computed. Then they are multiplied by a factor of 6 in order to obtain
larger values for the plots.

<<eval=FALSE>>=
x1 <- partypref/rowSums(partypref)

x1 <- x1[c(1,4,5,8),]

x1 <- cbind(x1[,2],x1[,3],x1[,1],x1[,4])

x1 <- x1*6
@

The locations for the plots are defined and the library "grDevices" is loaded. 

<<eval=FALSE>>=
loc1 <- matrix(data=c(0,0,15,0,0,15,15,15),ncol=2,byrow=T)
library(grDevices)
@

Now the stars are plotted by the command "stars".

<<eval=FALSE>>=
stars(x1, scale=FALSE,key.loc = c(25,6),len=2,cex=1.2,lwd=1.2,
xlim=c(-10,30),ylim=c(-5,10),key.labels=c("Liberals","Green","CDU","SPD"), 
location=loc1, labels = c("male young","male old","female young","female old"))
@

In the following a star plot for the exponentials of a multinomial model is plotted. First the model is fitted with the command "multinom" from "nnet"--package.


<<eval=FALSE>>=
partydat$age <- as.factor(partydat$age)

library(nnet)

partymult <- multinom(party ~ sex + age , data=partydat)

summary(partymult)
@

The exponentials of the model coefficients and the coefficients for the reference category "CDU" are used to build the matrix "x2" 
of the values needed for the star plot. In addition the locations for the respective stars are defined.

<<eval=FALSE>>=
x2 <- matrix(data=c(rep(1,5),as.matrix(t(exp(coefficients(partymult))))),nrow=5)

x2 <- cbind(x2[,4],x2[,3],x2[,1],x2[,2])

loc2 <- matrix(data=c(0,9,9,9,0,0,9,0,18,0),ncol=2,byrow=T)
@

Finally the stars can be plotted. The options "key.loc" and "key.labels" set the coordinates and the labels for the unit key.

<<eval=FALSE>>=
stars(x2, scale=FALSE,key.loc = c(18,9),len=2,cex=1.2,lwd=1.2,
xlim=c(-2,23),ylim=c(-3,10),key.labels=c("Liberals","Green","CDU","SPD"), 
location=loc2, labels = c("reference","gender","age 2","age 3","age 4"))
@

\end{document}

% \VignetteIndexEntry{Number of Children - Poisson Models with Polynomial Terms}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Number of Children - Poisson Models with Polynomial Terms}

\begin{document}

\maketitle

<<echo=FALSE,eval=TRUE>>=
options(width=80)
@



First of all, the children data is loaded:
<<results='hide',eval=TRUE>>=
library(catdata)
data(children)
attach(children)
@
A log-linear Poission model with the number of children as dependent variable is fitted.
Since one cannot expect that the metric predictors have linear effects, polynomial terms are included in the predictors. 
<<eval=TRUE>>=
pois <- glm(child ~ age+I(age^2)+I(age^3)+I(age^4)+dur+I(dur^2)+nation+god+univ, 
            data = children,  family = poisson(link=log))
summary(pois)
@

Visualizing the effect of age and duration for education.
<<eval=TRUE>>=
x <- min(age):max(age)
y <- exp(pois$coef[1]+pois$coef["age"]*x+pois$coef["I(age^2)"]*x^2+
  pois$coef["I(age^3)"]*x^3+pois$coef["I(age^4)"]*x^4+pois$coef["dur"]*10+
  pois$coef["I(dur^2)"]*100)
par(cex=1.4)
plot(x, y, ylab="Number of Children", xlab="Age")
@

<<eval=TRUE>>=
y <- (pois$coef[1]+pois$coef["age"]*x+pois$coef["I(age^2)"]*x^2+
  pois$coef["I(age^3)"]*x^3+pois$coef["I(age^4)"]*x^4+pois$coef["dur"]*10+
  pois$coef["I(dur^2)"]*100)
par(cex=1.4)
plot(x, y, ylab="Linear Predictor", xlab="Age")
@

<<eval=TRUE>>=
x <- min(dur):max(dur)
y <- exp(pois$coef[1]+pois$coef["age"]*40+pois$coef["I(age^2)"]*40^2+
  pois$coef["I(age^3)"]*40^3+pois$coef["I(age^4)"]*40^4+pois$coef["dur"]*x+
  pois$coef["I(dur^2)"]*x^2)
par(cex=1.4)
plot(x, y, ylab="Number of Children", xlab="Duration of School Education")
@

<<eval=TRUE>>=
y <- (pois$coef[1]+pois$coef["age"]*40+pois$coef["I(age^2)"]*40^2+
  pois$coef["I(age^3)"]*40^3+pois$coef["I(age^4)"]*40^4+pois$coef["dur"]*x+
  pois$coef["I(dur^2)"]*x^2)
par(cex=1.4)
plot(x, y, ylab="Linear Predictor", xlab="Duration of School Education")
@



Calculate the deviance of the Poisson model.
<<eval=TRUE>>=
anova(pois)
@

\end{document}

% \VignetteIndexEntry{Vaso Constriction - Logistic Regression}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Vaso Constriction - Logistic Regression}

\begin{document}

\maketitle
First the dataset vaso is loaded.
<<results='hide',eval=TRUE>>=
library(catdata)
data(vaso)
attach(vaso)
@
For the fitting of a logit model, the response is 0-1 coded. (data set contains 1 2).
Moreover, the covariates vol and rate are log-transformed.
<<eval=TRUE>>=
y <- vaso$vaso
y[vaso$vaso==2] <- 0
@
Fit of a logit-model with log-transformed covariates.
<<eval=TRUE>>=
vaso1 <- glm(y ~ vol + rate, family=binomial)
summary(vaso1)
@
Next,  a logit-model with original covariates is fitted.
<<eval=TRUE>>=
vaso2 <- glm(y ~ I(exp(vol)) + I(exp(rate)), family=binomial)
summary(vaso2)
@
\end{document}

% \VignetteIndexEntry{Retinopathy - Sequential Logit Models}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Retinopathy - Sequential Logit Models}

\begin{document}

<<include=FALSE>>=
library(knitr)
opts_chunk$set(
concordance=TRUE
)
@


\maketitle

<<echo=FALSE>>=
rm(list=ls(all=TRUE))
options(width=80)
@

<<results='hide'>>=
library(catdata)
data(retinopathy)
@

For sequential models again the "vglm"--function from the "VGAM"--library is needed, but now family option "sratio" is required.
<<>>=
library(VGAM)
@

Now several sequential logit models are fitted and compared by their corresponding deviances. The first model
is the sequential logit model with all category--specific effects, so the option "parallel=FALSE" is used.

<<>>=
seqm1 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logit", 
parallel=FALSE), data = retinopathy)
deviance(seqm1)
@

No category--specific effect for DIAB:

<<>>=
seqm2 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logit", 
parallel=FALSE ~ SM + GH + BP), data = retinopathy)
deviance(seqm2)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm2)-deviance(seqm1), df=1)
@

No category--specific effect for GH:

<<>>=
seqm3 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logit", 
parallel=FALSE ~ SM + BP), data = retinopathy)
deviance(seqm3)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm3)-deviance(seqm2), df=1)
@

No category--specific effect for BP:

<<>>=
seqm4 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logit", 
parallel=FALSE ~ SM), data = retinopathy)
deviance(seqm4)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm4)-deviance(seqm3), df=1)
@

No category--specific effect for GH (only global effects):

<<>>=
seqm5 <- vglm(RET ~ SM + DIAB + GH + BP, family = sratio (link="logit", 
parallel=TRUE), data = retinopathy)
deviance(seqm5)
@

Testing the removed effect:
<<>>=
1-pchisq(deviance(seqm5)-deviance(seqm4), df=1)
@

As the last test is significant, model "seqm4" is analyzed in detail.

<<>>=
summary(seqm4)
@

The summary gives no p--values for the individual covariates, they have to be computed separately. 
For this purpose the t--values are copied from the summary. The quadratic t--values are the wald--statistics which can be used to produce the individual 
p--values.

\bigskip

p--value intercept1:
<<>>=
1 - pchisq(9.5223^2, df=1)
@

p--value intercept2:
<<>>=
1 - pchisq(8.9957^2, df=1)
@

p--value SM1:
<<>>=
1 - pchisq((-1.8646)^2, df=1)
@

p--value SM2:
<<>>=
1 - pchisq(1.5687^2, df=1)
@

p--value DIAB:
<<>>=
1 - pchisq((-10.4303)^2, df=1)
@

p-value GH:
<<>>=
1 - pchisq((-6.3116)^2, df=1)
@

p--value BP:
<<>>=
1 - pchisq((-5.1037)^2, df=1)
@

To receive the corresponding odds--ratios, the following command can be used.

<<>>=
exp(coefficients(seqm4)[3:7])
@


<<echo=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Knee Injuries - Comparison of Link Functions}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Injuries - Comparison of Link Functions}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=80)
rm(list=ls(all=TRUE))
@

At the beginning the knee dataset is loaded:
<<results='hide',eval=FALSE>>=
library(catdata)
data(knee)
attach(knee)
@


In the following the variable Age is centered around $30$ years and the quadratic variable Age2 is created. 

<<eval=FALSE>>=
Age <- Age - 30
Age2 <- Age^2
@

For the cumulative maximum extreme value (Gumbel) model that will be fitted later, the response has to be transformed so that afterwards the
ordering of the response categories is reversed. 

<<eval=FALSE>>=
k <- length(unique(R4))
R4rev <- k + 1 - R4
@ 

The response pain (R4 or R4rev) is an ordered factor, the covariates therapy (Th) and sex (Sex) need to be factors.

<<eval=FALSE>>=
R4 <- as.ordered(R4)
R4rev <- as.ordered(R4rev)
Th <- as.factor(Th)
Sex <- as.factor(Sex)
@
 
With the "vglm"--function from the "VGAM"--library both cumulative and sequential models can be fitted.
<<eval=FALSE>>=
library(VGAM)
@

To compare the performance of cumulative models with different link functions one can use the deviances of the respective models. At first four models with 
four different link functions (Logit, Probit, Gumbel, Gompertz) are fitted.

\bigskip

Cumulative Logit model:
<<eval=FALSE>>=
clogit <- vglm(R4 ~ Th + Sex + Age +Age2, family = cumulative (link="logit", 
parallel=TRUE))
@

Cumulative Probit model:
<<eval=FALSE>>=
cprobit <- vglm(R4 ~ Th + Sex + Age +Age2, family = cumulative (link="probit",
parallel=TRUE))
@

Cumulative Gumbel model:
<<eval=FALSE>>=
cgumbel <- vglm(R4rev ~ Th + Sex + Age +Age2, family = cumulative(link="cloglog", 
parallel=TRUE))
@

Cumulative Gompertz model:
<<eval=FALSE>>=
cgompertz <- vglm(R4 ~ Th + Sex + Age +Age2, family = cumulative(link="cloglog", 
parallel=TRUE))
@

\bigskip

Now the four deviances can be recalled by the following command:
<<eval=FALSE>>=
deviance(clogit)
deviance(cprobit)
deviance(cgumbel)
deviance(cgompertz)
@

For comparison the four corresponding sequential models are fitted.

\bigskip

Sequential Logit model:
<<eval=FALSE>>=
slogit <- vglm(R4 ~ Th + Sex + Age +Age2, family = sratio (link="logit", 
parallel=TRUE))
@

Sequential Probit model:
<<eval=FALSE>>=
sprobit <- vglm(R4 ~ Th + Sex + Age +Age2, family = sratio (link="probit", 
parallel=TRUE))
@

Sequential Gumbel model:
<<eval=FALSE>>=
sgumbel <- vglm(R4rev ~ Th + Sex + Age +Age2, family = sratio (link="cloglog", 
parallel=TRUE))
@

Sequential Gompertz model:
<<eval=FALSE>>=
sgompertz <- vglm(R4 ~ Th + Sex + Age +Age2, family = sratio (link="cloglog",
parallel=TRUE))
@

Now the deviances of the sequential models are recalled:
<<eval=FALSE>>=
deviance(slogit)
deviance(sprobit)
deviance(sgumbel)
deviance(sgompertz)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Teratology - Alternative Binary Models}
% \VignetteDepends{VGAM, gee, MASS,glmmML,flexmix}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Teratology - Alternative Binary Models}

\begin{document}

\maketitle


<<echo=FALSE>>=
options(width=60)
@


First the teratology data are loaded. The data set exists in two different versions, "teratology" shows the aggregated 
count data whereas "teratology2" includes the original data.   
<<results="hide",eval = TRUE>>=
library(catdata)
data(teratology)
data(teratology2)
@

For the first two models, the simple independence model and the quasi-likelihood model, the aggregated data are needed.

<<results="hide",eval = TRUE>>=
attach(teratology)
@

The simple and naive independence model is fitted by the following command. 
<<eval = TRUE>>=
mLogit <- glm(cbind(D,L) ~ as.factor(Grp), family=binomial())
summary(mLogit)
@

Now the quasi--likelihood model is fitted. The coefficients are the same as in the independence model before, only the 
standard errors have to be multiplied by $\sqrt{\hat{\phi}}$.

<<eval = TRUE>>=
mQuasi <- glm(cbind(D,L) ~ as.factor(Grp), family=quasibinomial(link="logit"))
summary(mQuasi)
@

The next model to be fitted is a GEE with independence correlation structure. For that purpose
the library "gee" is loaded.

<<eval = TRUE>>=
library(gee)
@

Now we use the original data set "teratology2".

<<results="hide",eval = TRUE>>=
detach(teratology)
attach(teratology2)
@

The GEE is fitted by the following command. The coefficients are again equal to those from the independence model, 
the standard errors for the independence models can be found in the column "Naive S.E.". The new standard errors from the 
GEE are those in the column "Robust S.E.".

<<eval = TRUE>>=
mGee <- gee(y ~ as.factor(Grp), id=Rat, family=binomial)
summary(mGee) 
@

For the following beta--binomial model the library "VGAM" with its function "vglm" and the data set "teratology" is needed.

<<eval = TRUE>>=
library(VGAM)
@

<<results="hide",eval = TRUE>>=
detach(teratology2)
attach(teratology)
@

Furthermore we construct the Variable N as sum of all fetuses in one litter.
We will use N to make a subset with $N>1$ for the beta--binomial model.

<<eval = TRUE>>=
N <- D + L
@

Now the beta--binomial model is fitted.

<<eval = TRUE>>=
mBetaBin <- vglm(cbind(D,L) ~ as.factor(Grp), family=betabinomial, subset=N>1)
summary(mBetaBin)
@

For the following two  mixed models again the original data are required.

<<results="hide",eval = TRUE>>=
detach(teratology)
attach(teratology2)
@

With the function "glmmPQL" from the "MASS"--library a mixed model is fitted by penalized quasi--likelihood, the mixed model 
contains random intercepts but no random slopes.

<<eval = TRUE>>=
mMixPql<- glmmPQL(y ~ as.factor(Grp), random=~1 | Rat, family=binomial)
summary(mMixPql)
@

In order to fit a mixed model by maximum likelihood we load the library "glmmML". 

<<eval = TRUE>>=
library(glmmML)
@                                                  

For a mixed model to be fitted by Gauss--Hermite quadrature we need the function "glmmML" 
with the option "method='ghq'", the favoured number of quadrature points is determined by the option "n.points".

<<eval = TRUE>>=
mGaussH <- glmmML(y ~ as.factor(Grp), cluster=Rat, method = "ghq", n.points = 14,
                  boot = 0) 
summary(mGaussH)
@

Again we change the data set, for the discrete mixture model "teratology" is required.

<<results="hide",eval = TRUE>>=
detach(teratology2)
attach(teratology)
@

For discrete mixture models the library "flexmix" with its functions "flexmix" and "stepFlexmix" can be used.

<<eval = TRUE>>=
library(flexmix)
@

In "stepFlexmix" the procedure is run several times, the maximum likelihood solution is returned. The favoured 
number of iterations can be specified by the option "nrep". The number of components is determined by the option "k".

Due to random processes the results of different runs of "stepFlexmix" will differ slightly.

<<results="hide",eval = TRUE>>=
detach(package:VGAM)
library(stats4)
@

<<eval = TRUE>>=
mDiscmix <-stepFlexmix(cbind(D,L) ~ 1, k = 2, nrep=5,
                 model = FLXMRglmfix(family = "binomial",fixed =~as.factor(Grp)))
summary(mDiscmix)
parameters(mDiscmix)
@


\end{document}

% \VignetteIndexEntry{Encephalitis - Loglinear Poisson Model and Normal Distribution Model}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Encephalitis - Loglinear Poisson Model and Normal Distribution Model}

\begin{document}

\maketitle
First of all, the encephalitis data are loaded:
<<results='hide',eval=TRUE>>=
library(catdata)
data(encephalitis)
attach(encephalitis)
@


Some variables are renamed and recoded before fitting the model.
<<eval=TRUE>>=
BAV <- country
BAV[BAV==2] <-0
TIME <- year
@
%
The number of infections (count) is modeled in dependence on country and TIME.
A Loglinear Poisson Model is fitted.
<<eval=TRUE>>=
enc1 <- glm(count ~ TIME+I(TIME^2)+BAV+TIME*BAV, family = poisson)
summary(enc1)
@
%
For comparison the linear Normal Model with the identity link is fitted.
<<eval=TRUE>>=
enc2 <- glm(count ~ TIME+I(TIME^2)+BAV+TIME*BAV, family = gaussian("identity"))
summary(enc2)
@
%
Fit of loglinear Normal Model. That means a normal model with log-link.
<<eval=TRUE>>=
enc3 <- glm(count ~ TIME+I(TIME^2)+BAV+TIME*BAV, family = gaussian("log"), 
            start=enc1$coef)
summary(enc3)
@

\end{document}

% \VignetteIndexEntry{Knee Data - Random Effects Logit Models}
% \VignetteDepends{gee}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Data - Random Effects Logit Models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@


First the knee dataset is loaded:

<<results='hide',eval=FALSE>>=
library(catdata)
data(knee)
@


For the following models the data set is transformed into long format what can be done by the function "reshape". 

In addition the dichotomized response variables "RD" is created. The groups are constructed by
pain level up to level 2 und pain level higher than level 2.

<<eval=FALSE>>=
knee <- reshape(knee, direction="long", varying=list(5:8), v.names="R",timevar="Time")

knee$RD <- rep(0, length(knee$R))
knee$RD[knee$R>2] <- 1
@

For better interpretability the variable "Age" is centered around 30 , the variable "Age2" is created as quadratic effect of "Age".

<<eval=FALSE>>=
knee$Age <- knee$Age - 30
knee$Age2 <- knee$Age^2  
@

Since only the measurements 2, 3 and 4 are used for the models, measurement 1 can be eliminated.

<<eval=FALSE>>=
knee <- knee[knee$Time!=1,]
@

The first model will be fitted by Gauss--Hermite--Quadrature with 20 quadrature points by using function "glmmML" from library "glmmML".

<<eval=FALSE>>=
library(glmmML)
@

Now the random intercept model with Gauss--Hermite--Quadrature is fitted, the option "method" has to be set on "ghq", the number of quadrature points is set by "n.points".

<<eval=FALSE>>=
kneeGHQ <- glmmML(RD ~ as.factor(Th) + as.factor(Sex) + Age + Age2, data=knee, 
family=binomial(), method="ghq", n.points=20, cluster=id)
summary(kneeGHQ)
@

The random intercept model with Penalized Quasi--Likelihood is fitted by use of "glmmPQL" from the library "MASS". 

<<eval=FALSE>>=
kneePQL <- glmmPQL(RD ~ as.factor(Th) + as.factor(Sex) + Age + Age2, data=knee, 
random = ~ 1|id, family=binomial())
summary(kneePQL)
@

The library "gee" is needed for fitting of the marginal model.

<<eval=FALSE>>=
library(gee)
@

For the marginal model the data set has to be arranged according to the variable "id" so that 
measurements from the same individual are arranged one after the other. 

<<eval=FALSE>>=
knee <- knee[order(knee$id),]
kneeGEE <- gee(RD ~ as.factor(Th) + as.factor(Sex) + Age + Age2, data=knee, 
family=binomial(), id=id, corstr="exchangeable")
summary(kneeGEE)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:gee)
@

\end{document}

% \VignetteIndexEntry{AIDS - Semiparametric Mixed Model}
% \VignetteDepends{mgcv}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{AIDS - Semiparametric Mixed Model}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

The "AIDS"--data from "catdata" are loaded.

<<eval=FALSE>>=
library(catdata)
data(aids)
@

As for normal GAMs for GAMMs the package "mgcv" is used.

<<eval=FALSE>>=
library(mgcv)
@

The Semiparametric Mixed Model (or Generalized Additive Mixed Model) for "AIDS"--Data is fitted by the function "gamm". Here the only random effect is 
the random intercept.

<<eval=FALSE>>=
gammaids<-gamm(cd4 ~ s(time) + drugs + partners + s(cesd) + s(age), 
               random=list(person=~1),  family=poisson(link=log), data=aids)
@

The summary of the fixed effects is printed.

<<eval=FALSE>>=
summary(gammaids$gam)
@

Finally the three smooth effects from the gam are plotted.

<<fig.width=12, fig.height=9,eval=FALSE>>=
plot(gammaids$gam,ylab=" ",cex.lab=1.8,cex.axis=1.5,select=1)
@

<<fig.width=12, fig.height=9,eval=FALSE>>=
plot(gammaids$gam,ylab=" ",cex.lab=1.8,cex.axis=1.5,select=2)
@


<<fig.width=12, fig.height=9,eval=FALSE>>=
plot(gammaids$gam,ylab=" ",cex.lab=1.8,cex.axis=1.5,select=3)
@
<<echo=FALSE,results='hide',eval=FALSE>>=
detach(package:mgcv)
@

\end{document}

% \VignetteIndexEntry{Preference for Political Parties - Multinomial Logit Model}
% \VignetteDepends{nnet}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Preference for Political Parties - Multinomial Logit Model}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=60)
@

The dataset "partydat" is built by reading the data as a matrix given in "partypref".

<<eval=FALSE>>=
partypref <- matrix(data=c(114, 10, 53,224,134,9,42,226,114,8,23,174,339,30,13,
414,42,5,44,161,88,10, 60,171,90,8,31,168,413,23,14,375), nrow=8, byrow=TRUE)


partydat<-data.frame(
party=c(rep("CDU",sum(partypref[,1])),rep("SPD",sum(partypref[,4])),
rep("The Liberals",sum(partypref[,2])),rep("The Greens",sum(partypref[,3]))),
sex=c(rep(0,sum(partypref[1:4,1])),rep(1,sum(partypref[5:8,1])),
rep(0,sum(partypref[1:4,4])),rep(1,sum(partypref[5:8,4])),
rep(0,sum(partypref[1:4,2])),rep(1,sum(partypref[5:8,2])),
rep(0,sum(partypref[1:4,3])),rep(1,sum(partypref[5:8,3]))),
age=c(rep(c(1:4,1:4), partypref[,1]),rep(c(1:4,1:4), partypref[,4]),
rep(c(1:4,1:4), partypref[,2]),rep(c(1:4,1:4), partypref[,3])))

@

For the fitting of a multinomial logit model the function "multinom" from the "nnet"--package is used.

<<eval=FALSE>>=
library(nnet)
@

The reference category for the multinomial logit model is taken alphabetically so in this case "CDU" is the reference category.

<<eval=FALSE>>=
datmat<-as.matrix(table(partydat$sex,partydat$party))
tparty<-data.frame("CDU"=datmat[,1],"SPD"=datmat[,2],"Green"=datmat[,3],
"Liberals"=datmat[,4],"sex"=0:1)
tparty

logitParty <- multinom(cbind(CDU,SPD,Green,Liberals)~sex, data=tparty)

summary(logitParty)
exp(coef(logitParty))
@


From the model with "CDU" as reference category the corresponding parameters for "SPD" are easily derived:

<<eval=FALSE>>=
coefSPD <- matrix(data = c(-coefficients(logitParty)[3,1],
coefficients(logitParty)[1,1] - coefficients(logitParty)[3,1],
coefficients(logitParty)[2,1] - coefficients(logitParty)[3,1],
-coefficients(logitParty)[3,2],
coefficients(logitParty)[1,2] - coefficients(logitParty)[3,2],
coefficients(logitParty)[2,2] - coefficients(logitParty)[3,2]),
nrow=3, ncol=2)

coefSPD

exp(coefSPD)
@

\end{document}

% \VignetteIndexEntry{Exposure to Dust - Trees}
% \VignetteDepends{rpart, party}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Exposure to Dust - Trees}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

First the dust data are loaded from the package "catdata".

<<eval=FALSE>>=
library(catdata)
data(dust)
@

Trees can be fitted by use of the function "rpart" from package "rpart".

<<eval=FALSE>>=
library(rpart)
@

Now a tree is fitted. We take "years" as the only covariate, "bronch" is the binary response. Afterwards the corresponding tree is plotted.

<<fig.width=8,eval=FALSE>>=
tree1 <-rpart(as.factor(bronch) ~ years, data = dust, 	method = "class",
              control = rpart.control(cp = 0.001,  parms=list(split='information'),
                                      maxdepth = 4))
plot(tree1, xpd=TRUE)
text(tree1)
@

In the following the fit is plotted. It shows how the tree  can be interpreted as regression function.

<<eval=FALSE>>=
 	pred <- predict(tree1)
 	year<- dust$years
 	year [dust$years<15.5] <- 1
 	year [dust$years>15.5 & dust$years<36.5] <- 2
 	year [dust$years>36.5 & dust$years<47.5] <- 3
 	year [dust$years>47.5 & dust$years<50.5] <- 4 	
 	year [dust$years>50.5] <- 5
 	
pre5 <- unique( pred[,2][year==5])
pre4 <- unique( pred[,2][year==4])
pre3 <- unique( pred[,2][year==3])
pre2 <- unique( pred[,2][year==2])
pre1 <- unique( pred[,2][year==1])
 	      
meanyear <- c()

for (i in min(dust$years):max(dust$years)){
meanyear[i] <- sum(dust$bronch[dust$year==i])
if(sum(dust$bronch[dust$year==i])!=0){
meanyear[i] <- mean(dust$bronch[dust$year==i])
}
}

dust$means<- rep(2, nrow(dust)) 
 
 for (k in 1:nrow(dust)){
 dust$means[k] <- meanyear[dust$years[k]]
 }
@

<<fig.width=8,eval=FALSE>>=
 plot(dust$years, dust$means, xlab="years",ylab="")
 segments(x0=3,x1=15.5,y0=pre1)
 segments(x0=15.5,x1=15.5,y0=pre1,y1=pre2)
 segments(x0=15.5,x1=36.5,y0=pre2)
 segments(x0=36.5,x1=36.5,y0=pre2,y1=pre3)
 segments(x0=36.5,x1=47.5,y0=pre3)
  segments(x0=47.5,x1=47.5,y0=pre3,y1=pre4)
 segments(x0=47.5,x1=50.5,y0=pre4)
  segments(x0=50.5,x1=50.5,y0=pre4,y1=pre5)
 segments(x0=50.5,x1=66,y0=pre5)
@

An alternative package to generate trees is "party" which contains the function "ctree".

<<eval=FALSE>>=
library(party)
@

As before with "rpart" we fit a tree with "years" as only covariate.

<<fig.width=8,eval=FALSE>>=
treeP1 <-ctree(as.factor(bronch) ~ years, data = dust)
plot(treeP1)
@
<<eval=FALSE>>=
 	year<- dust$years
 	year [dust$years<7.5] <- 1
 	year [dust$years>7.5 & dust$years<15.5] <- 2
 	year [dust$years>15.5 & dust$years<36.5] <- 3
 	year [dust$years>36.5] <- 4
 	
pre4 <- mean(dust$bronch[year==4])
pre3 <- mean(dust$bronch[year==3])
pre2 <- mean(dust$bronch[year==2])
pre1 <- mean(dust$bronch[year==1])
@
 	      
<<fig.width=8,eval=FALSE>>=
 plot(dust$years, dust$means, xlab="years",ylab="")
 segments(x0=3,x1=7.5,y0=pre1)
 segments(x0=7.5,x1=7.5,y0=pre1,y1=pre2)
 segments(x0=7.5,x1=15.5,y0=pre2)
 segments(x0=15.5,x1=15.5,y0=pre2,y1=pre3)
 segments(x0=15.5,x1=36.5,y0=pre3)
  segments(x0=36.5,x1=36.5,y0=pre3,y1=pre4)
 segments(x0=36.5,x1=66,y0=pre4)

@


Now we take "smoke", "years" and "dust" as covariates for the binary response "bronch" and again plot the tree.

<<fig.width=8,eval=FALSE>>=
treeP2 <-ctree(as.factor(bronch) ~ smoke + years + dust, data = dust)
plot(treeP2)
@


<<echo=FALSE,results='hide',eval=FALSE>>=
detach(package:rpart)
detach(package:party)
@
\end{document}

% \VignetteIndexEntry{Insolvency - (Quasi-)Poisson Model and Negative Binomial Model}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Insolvency - (Quasi-)Poisson Model and Negative Binomial Model}

\begin{document}

\maketitle
First the insolvency data are loaded:
<<results='hide',eval=TRUE>>=
library(catdata)
data(insolvency)
attach(insolvency)
@
%
For the number of insolvent firms between 1994 and 1996 a Poisson model is fitted with time as predictor.
Time is considered as a number from 1 to 36, denoting the month from January 1994 to December 1996.
<<eval=TRUE>>=
ins1 <- glm(insolv ~ case + I(case^2), family=poisson(link=log), data=insolvency)
summary(ins1)
# plot(ins1)
@
Scatter-Plot of number of insolvent firms dependent of the month (1-36). With estimated curve of the log-linear model.
<<eval=TRUE>>=
plot(case, insolv)
points(ins1$fitted.values, type="l")
@
In many real-world datasets the variance of count-data is higher than predicted by the Poisson distribution.
So next a Poisson model with disperison parameter is fitted (Quasi-Poisson model).
<<eval=TRUE>>=
ins2 <- glm(insolv ~ case + I(case^2), family=quasipoisson, data=insolvency)
summary(ins2)
# plot(ins2)
@
An alternative to a quasi-poisson model is to use the negative binomial distribution.
<<eval=TRUE>>=
library(MASS)
ins3 <- glm.nb(insolv ~ case + I(case^2),data=insolvency)
summary(ins3)
@
Since counts are rather large in addition a normal distribution model is fitted.
<<eval=TRUE>>=
ins4 <- glm(insolv ~ case + I(case^2), family=gaussian(link=log), data=insolvency)
summary(ins4)
@
\end{document}

% \VignetteIndexEntry{Duration of Unemployment - Logit Model}
% \VignetteDepends{}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Duration of Unemployment - Logit Model}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=60)
@

At first the "unemployment" data from the "catdata" package are loaded and attached.
<<results='hide',eval=FALSE>>=
library(catdata)
data(unemployment)
attach(unemployment)
@


Now a frequency table is created and used to fit a Logit model based on grouped data.
<<eval=FALSE>>=
durbin <- as.factor(durbin)
table.durbin <- ftable(subset(unemployment, select=c("age", "durbin")), 
col.vars="durbin")
rels<-table.durbin[,1]/rowSums(table.durbin)
age.new <- min(age):max(age)

model1 <- glm(table.durbin ~ age.new, family=binomial)
summary(model1)
@

Here the observed frequencies are plotted against the fitted probabilities.

<<eval=FALSE>>=
plot(age.new, model1$fitted.values, xlab="Age", ylab="Observed/Fitted values", 
type="l", ylim=c(0,1))
points(age.new,table.durbin[,1]/rowSums(table.durbin))
@

The standardized deviance residuals are plotted against the predicted values and a quantile plot is created.

<<eval=FALSE>>=
plot(model1$fitted.values,sqrt(rowSums(table.durbin))*rstandard(model1), 
xlab="Predicted values", ylab="Residuals")
@
<<eval=FALSE>>=
qqnorm(sqrt(rowSums(table.durbin))*rstandard(model1), main="", 
       ylab="Standardized deviance residuals")
qqline(sqrt(rowSums(table.durbin))*rstandard(model1), lwd=2.5, 
       lty="dashed", col="red")
@

\end{document}

% \VignetteIndexEntry{Birth Data - Loglinear Models}
% \VignetteDepends{stats}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Birth Data - Loglinear Models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

<<results='hide',eval=FALSE>>=
library(catdata)

data(birth)
attach(birth)
@

In the following loglinear models are fitted with the binary variables Sex, Membranes, Cesarean and Induced
from the "birth" data. As an overview a contingency table is plotted.

<<eval=FALSE>>=
table1 <- table(Sex, Membranes, Cesarean, Induced)

ftable(table1)
@

Now we start fitting the models. The goal is to find a model with good fit but sparse parametrization.

First the saturated model is fitted, then the model with all 3--factor interactions and the model with all 2--factor interactions, and
finally the independence model. To control for model fit we look at the corresponding deviances and degrees of freedom.

<<eval=FALSE>>=
m4 <- loglin(table1, margin=list(c(1,2,3,4)), fit=TRUE)
cat("deviance(m4)=", m4$lrt, "df(m4)=", m4$df, "\n")

m3 <- loglin(table1, margin=list(c(1,2,3), c(1,2,4), c(1,3,4), c(2,3,4)), fit=TRUE)
cat("deviance(m3)=", m3$lrt, "df(m3)=", m3$df, "\n")

m2 <- loglin(table1, margin=list(c(1,2), c(1,3), c(1,4), c(2,3), c(2,4), c(3,4)), 
             fit=TRUE)
cat("deviance(m2)=", m2$lrt, "df(m2)=", m2$df, "\n")

m1 <- loglin(table1, margin=list(c(1), c(2), c(3), c(4)), fit=TRUE)
cat("deviance(m1)=", m1$lrt, "df(m1)=", m1$df, "\n")
@

In order to see if a model or rather the reduction of a model is appropriate we use  chi--square tests.

<<eval=FALSE>>=
(df34 <- m3$df - m4$df)
(dev34 <- m3$lrt - m4$lrt)
1-pchisq(dev34, df34)


(df23 <- m2$df - m3$df)
(dev23 <- m2$lrt - m3$lrt)
1-pchisq(dev23, df23)

(df12 <- m1$df - m2$df)
(dev12 <- m1$lrt - m2$lrt)
1-pchisq(dev12, df12)
@

Since model "m2" fits the data well but model "m1" is definitely rejected  we fit submodels of "m2" by leaving out one of the  2--factor interactions.

<<eval=FALSE>>=
m2.GM <- loglin(table1, margin=list(c(1,3), c(1,4), c(2,3), c(2,4), c(3,4)), 
                fit=TRUE)
cat("deviance(m2.GM)=", m2.GM$lrt, "df(m2.GM)=", m2.GM$df, "\n")

m2.MC <- loglin(table1, margin=list(c(1,2), c(1,3), c(1,4), c(2,4), c(3,4)), 
                fit=TRUE)
cat("deviance(m2.MC)=", m2.MC$lrt, "df(m2.MC)=", m2.MC$df, "\n")

m2.CI <- loglin(table1, margin=list(c(1,2), c(1,3), c(1,4), c(2,3), c(2,4)), 
                fit=TRUE)
cat("deviance(m2.CI)=", m2.CI$lrt, "df(m2.CI)=", m2.CI$df, "\n")

m2.GI <- loglin(table1, margin=list(c(1,2), c(1,3), c(2,3), c(2,4), c(3,4)), 
                fit=TRUE)
cat("deviance(m2.GI)=", m2.GI$lrt, "df(m2.GI)=", m2.GI$df, "\n")

m2.GC <- loglin(table1, margin=list(c(1,2), c(1,4), c(2,3), c(2,4), c(3,4)), 
                fit=TRUE)
cat("deviance(m2.GC)=", m2.GC$lrt, "df(m2.GC)=", m2.GC$df, "\n")

m2.MI <- loglin(table1, margin=list(c(1,2), c(1,3), c(1,4), c(2,3), c(3,4)), 
                fit=TRUE)
cat("deviance(m2.MI)=", m2.MI$lrt, "df(m2.MI)=", m2.MI$df, "\n")
@

These six models all have 6 degrees of freedom so that the difference of degrees of freedom corresponding to
model "m2" is 1 in each case.

<<eval=FALSE>>=
1 - pchisq(m2.GM$lrt - m2$lrt, 1)

1 - pchisq(m2.MC$lrt - m2$lrt, 1)

1 - pchisq(m2.CI$lrt - m2$lrt, 1)

1 - pchisq(m2.GI$lrt - m2$lrt, 1)

1 - pchisq(m2.GC$lrt - m2$lrt, 1)

1 - pchisq(m2.MI$lrt - m2$lrt, 1)
@

Testing of the 2--factor interactions shows that the interactions "MC", "CI" and "MI"  should be kept in the model.
In the next step the model that contains these interactions,  G|MC|MI|CI, is fitted.

<<eval=FALSE>>=
m2.GM.GI.GC<- loglin(table1, margin=list(c(1), c(2,3), c(2,4), c(3,4)), fit=TRUE)
cat("deviance(m2.GM.GI.GC)=", m2.GM.GI.GC$lrt, "df(m2.GM.GI.GC)=", m2.GM.GI.GC$df, 
    "\n")

1 - pchisq(m2.GM.GI.GC$lrt - m2$lrt, m2.GM.GI.GC$df - m2$df)
@

Comparison with model "m2" shows that reduction is possible. However, reduction to a  model in which the main effect
"G" is omitted is rejected.

<<eval=FALSE>>=
m2.G<- loglin(table1, margin=list(c(2,3), c(2,4), c(3,4)), fit=TRUE)
cat("deviance(m2.G)=", m2.G$lrt, "df(m2.G)=", m2.G$df, "\n")

1 - pchisq(m2.G$lrt - m2$lrt, m2.G$df - m2$df)
@
\end{document}

% \VignetteIndexEntry{Retinopathy - Testing Proportional Odds Assumption}
% \VignetteDepends{VGAM}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
    \documentclass[a4paper]{article}

\title{Retinopathy - Testing Proportional Odds Assumption}

\begin{document}

<<include=FALSE>>=
library(knitr)
opts_chunk$set(
concordance=TRUE
)
@


\maketitle

<<echo=FALSE>>=
options(width=60)
rm(list=ls(all=TRUE))
@

<<results='hide'>>=
library(catdata)
data(retinopathy)
retinopathy$SM <- as.factor(retinopathy$SM)
@

For the fitting of the partial proportional odds models the function "vglm" from the "VGAM"--package is used. First a simple
proportional odds model is fitted with "vglm". 

For the "vglm"--function the response (RET) does not necessarily have to be ordered, SM has to be factorized.

<<>>=
library(VGAM)
# retinopathy$RET <- as.ordered(retinopathy$RET)
# retinopathy$SM <- as.factor(retinopathy$SM)
@


The models differ in the option "parallel" for the used family "cumulative". 

<<results='hide'>>=
pom <- vglm(RET ~ SM + DIAB + GH + BP, family = cumulative(parallel=TRUE), 
            data = retinopathy)
@

<<results='hide'>>=
ppom <- vglm(RET ~ SM + DIAB + GH + BP, family = cumulative(parallel=FALSE), 
             data = retinopathy)
@

First the proportional odds assumption is tested. The deviances of the two models can be received by the following command.

<<>>=
deviance(pom)
@

<<>>=
deviance(ppom)
@

The p--value for the proportional odds assuption is computed:

<<>>=
1 - pchisq(deviance(pom) - deviance(ppom), df=4)
@

Coefficients and standard errors of both models are obtainen in the corresponding summaries. 
\bigskip

Summary proportional odds model:
<<>>=
summary(pom)
@

\bigskip
Summary partial proportional odds model:
<<>>=
summary(ppom)
@

\bigskip

Now the proportional odds assumption for all covariates is taken away step by step. 
Afterwards the corresponding proportional odds assumptions are tested. 

\bigskip
 
Global effect for BP:
<<>>=
ppom2 <- vglm (RET ~ SM + DIAB + GH + BP,
family = cumulative (parallel = FALSE ~ SM + DIAB + GH), data = retinopathy)
deviance(ppom2)
@

<<>>=
1-pchisq(deviance(ppom2)-deviance(ppom), df=1)
@


Global effect for GH:
<<>>=
ppom3 <- vglm (RET ~ SM + DIAB + GH + BP, 
family = cumulative (parallel = FALSE ~ SM + DIAB), data = retinopathy)
deviance(ppom3)
@

<<>>=
1-pchisq(deviance(ppom3)-deviance(ppom2), df=1)
@

Global effect for DIAB:
<<>>=
ppom4 <- vglm (RET ~ SM + DIAB + GH + BP, 
family = cumulative (parallel = FALSE ~ SM), data = retinopathy)
deviance(ppom4)
@

<<>>=
1-pchisq(deviance(ppom4)-deviance(ppom3), df=1)
@

Global effect for SM (equivalent to proportional odds model):
<<>>=
1-pchisq(deviance(pom)-deviance(ppom4), df=1)
@

<<echo=FALSE>>=
detach(package:VGAM)
@
\end{document}

% \VignetteIndexEntry{Addiction - Multinomial Model with Hierarchically Structured Response}
% \VignetteDepends{nnet}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Addiction - Multinomial Model with Hierarchically Structured Response}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
rm(list=ls(all=TRUE))
options(width=60)
@

First the "addiction" data are loaded and attached.

<<results='hide',eval=FALSE>>=
library(catdata)
data(addiction)
attach(addiction)
@

For the Multinomial Model with hierarchically structured response we use simple Logit Models. For the first model, which models the effect of categories 
0 and 1 versus 2, a new response "ill01" is created. In addition the variable "age2" for the squared effect of age is created.

<<eval=FALSE>>=
ill01 <- ill
ill01[ill==0] <- 1
ill01[ill==2] <- 0

age2 <- age^2
@

Now the model for categories 0 and 1 versus 2 is fitted.

<<eval=FALSE>>=
m01vs2 <- glm(ill01 ~ as.factor(gender) + as.factor(university) + age + age2, 
family=binomial())
summary(m01vs2)
@

For the next model the data set has to be reduced, only observations with response categories 0 or 1 are needed. Then the variable "age2" is built.

<<results='hide',eval=FALSE>>=
detach(addiction)
addiction2 <- addiction[addiction$ill!=2,]
attach(addiction2)
age2 <- age^2
@

Finally the model for categories 0 versus 1 is fitted.

<<eval=FALSE>>=
m0vs1 <- glm(ill ~ as.factor(gender) + as.factor(university) + age + age2, 
family=binomial())
summary(m0vs1)
@

\end{document}

% \VignetteIndexEntry{Beta-blockers - Discrete Mixture Models}
% \VignetteDepends{flexmix}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Beta-blockers - Discrete Mixture Models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

The data set "betablockers" is loaded from the package "flexmix".

<<eval=FALSE>>=
library(flexmix)
data(betablocker)
@

<<eval=FALSE>>=
betablocker$Treatment <- as.factor(betablocker$Treatment)
@

First a simple logit model is fitted with the only covariate "Treatment".

<<eval=FALSE>>=
GlmT <- glm(cbind(Deaths, Total	- Deaths) ~ Treatment, family = "binomial", 
data = betablocker)
summary(GlmT)
@

Now the logit model  is extended by the factor "Center" which has 22 different values. The deviance reduces from 305.76
with 42 degrees of freedom to 23.62 with 21 degrees of freedom.

<<eval=FALSE>>=
GlmTC <- glm(cbind(Deaths, Total - Deaths) ~ Treatment + as.factor(Center), 
             family 	= "binomial", data = betablocker)
summary(GlmTC)
@

In the following two mixed models are fitted with Gauss--Hermite--Quadrature, so "glmmML" is needed.

<<eval=FALSE>>=
library(glmmML)
@

First the random intercept model with 4 quadrature points is fitted.

<<eval=FALSE>>=
MixedGH4 <- glmmML(cbind(Deaths, Total - Deaths) ~ Treatment, cluster=Center, 
                   method = c("ghq"), n.points = 4, boot = 0, data=betablocker)

summary(MixedGH4)
@

Now we use 20 quadrature points but there is no big difference in coefficients.

<<eval=FALSE>>=
MixedGH20 <- glmmML(cbind(Deaths, Total - Deaths) ~ Treatment, cluster=Center, 
                    method = c("ghq"), n.points = 20, boot = 0, data=betablocker)

summary(MixedGH20)
@

<<eval=FALSE>>=
set.seed(5)
@

Finally we fit the discrete mixture models for which the function "stepFlexmix" is used. 
Here we use three components  defined by option "k=3".  

<<results='hide',eval=FALSE>>=
detach(package:glmmML)
@

<<eval=FALSE>>=
MixFix3 <-stepFlexmix(cbind(Deaths, Total - Deaths) ~ 1 | Center,	model = 
  FLXMRglmfix(family = "binomial", fixed = ~ Treatment), k = 3, nrep = 5, 
                      data = betablocker)
@

Typing the name of the fitted model yields the sizes of the three clusters.

<<eval=FALSE>>=
MixFix3
@

The coefficients are printed by the command "parameters()".

<<eval=FALSE>>=
parameters(MixFix3)
@

The command "summary()" returns for example the estimated component weights and the BIC. The coefficients with standard errors and p--values can be found by "summary(refit())".

<<results='hide',eval=FALSE>>=
library(flexmix)
@

<<eval=FALSE>>=
summary(MixFix3)
summary(refit(MixFix3))
@

<<eval=FALSE>>=
set.seed(5)
@

Finally the discrete mixture model with 4 components is fitted.

<<eval=FALSE>>=
MixFix4 <-stepFlexmix(cbind(Deaths, Total - Deaths) ~ 1 | Center, model = 
  FLXMRglmfix(family = "binomial", fixed = ~ Treatment), k = 4, nrep = 5, 
                      data = betablocker)
@

<<eval=FALSE>>=
MixFix4
@

<<eval=FALSE>>=
parameters(MixFix4)
@

<<eval=FALSE>>=
summary(MixFix4)
summary(refit(MixFix4))
@
<<echo=FALSE,results='hide',eval=FALSE>>=
detach(package:flexmix)
@

\end{document}

% \VignetteIndexEntry{Knee Injuries - Marginal Models}
% \VignetteDepends{gee, geepack}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Knee Injuries - Marginal Models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

First the dataset knee is loaded:

<<results='hide',eval=FALSE>>=
library(catdata)
data(knee)
attach(knee)
@


To obtain  a simple binary model the response variables are dichotomized. The groups are constructed by
pain level up to level 2 und pain level higher than level 2.

<<eval=FALSE>>=
R2D <- rep(0, length(R2))
R3D <- rep(0, length(R3))
R4D <- rep(0, length(R3))

R2D[R2>2] <- 1
R3D[R3>2] <- 1
R4D[R4>2] <- 1
@

Now the covariates have to be transformed  so that they can be used for the functions "gee" from the
"gee"--library and "geeglm" from the "geepack"--library, which will be employed for fitting the models.

<<eval=FALSE>>=
N <- rep(knee$N, each=3)
Th <- rep(knee$Th, each=3)
Age <- rep(knee$Age, each=3)
Sex <- rep(knee$Sex, each=3)
@

Now the response vector is built and the quadratic age--effect "Age2" is computed.

<<eval=FALSE>>=
Response <- c(rbind(R2D,R3D,R4D))
Age2 <- Age^2
@

The covariates therapy and sex are treated as factors:

<<eval=FALSE>>=
Th <- as.factor(Th)
Sex <- as.factor(Sex)
@

First the GEEs are fitted with the funtion "gee" from library "gee".

<<eval=FALSE>>=
library(gee)
@

The first model is a GEE with independent correlation structure:

<<results='hide',eval=FALSE>>=
gee1a <- gee(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit))
@

<<eval=FALSE>>=
summary(gee1a)
@

The second model is a GEE with exchangeable correlation structure:

<<results='hide',eval=FALSE>>=
gee2a <- gee(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit), corstr="exchangeable")
@

<<eval=FALSE>>=
summary(gee2a)
@

Finally a GEE with exponential correlation structure is fitted:

<<results='hide',eval=FALSE>>=
gee3a <- gee(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit), corstr="AR-M", Mv=1)
@

<<eval=FALSE>>=
summary(gee3a)
@


In the following the corresponding marginal models are fitted with the function "geeglm" from the library "geepack".

<<eval=FALSE>>=
library(geepack)
@

Model with independent correlation structure:

<<results='hide',eval=FALSE>>=
gee1b <- geeglm(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit))
@

<<eval=FALSE>>=
summary(gee1b)
@

Model with exchangeable correlation structure:

<<results='hide',eval=FALSE>>=
gee2b <- geeglm(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit), corstr="exchangeable")
@

<<eval=FALSE>>=
summary(gee2b)
@

Model with exponential correlation structure:

<<results='hide',eval=FALSE>>=
gee3b <- geeglm(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit), corstr="ar1")
@

<<eval=FALSE>>=
summary(gee3b)
@

\bigskip

For comparison a simple GLM with logit--link is fitted with the same covariates as in the marginal models above:

<<eval=FALSE>>=
glm1 <- glm(Response ~ Th + Sex + Age + Age2,
family=binomial(link=logit))
summary(glm1)
@

It is often advatageous to center the  variables like age around a value in the middle of its range. So 
now the marginal models from above are replicated with  age  centered around 30 years. 

<<eval=FALSE>>=
Age <- Age-30
Age2 <- Age^2
@

Again we use the function "gee" from the "gee"--library for fitting those models.

\bigskip

Model with independent correlation structure and centered age:

<<results='hide',eval=FALSE>>=
gee1c <- gee(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit))
@

<<eval=FALSE>>=
summary(gee1c)
@

Model with exchangeable correlation structure and centered age:

<<results='hide',eval=FALSE>>=
gee2c <- gee(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit), corstr="exchangeable")
@

<<eval=FALSE>>=
summary(gee2c)
@

Model with exponential correlation structure and centered age:

<<results='hide',eval=FALSE>>=
gee3c <- gee(Response ~ Th + Sex + Age + Age2, id=N,
family=binomial(link=logit), corstr="AR-M", Mv=1)
@

<<eval=FALSE>>=
summary(gee3c)
@



\end{document}

% \VignetteIndexEntry{Duration of Unemployment - Trees}
% \VignetteDepends{party}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Duration of Unemployment - Trees}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

<<eval=FALSE>>=
library(catdata)
data(unemployment,package="catdata")
@

To fit a tree for the unemployment data we use "ctree" from the library "party". 

<<fig.width=9,eval=FALSE>>=
library(party)
tree1<-ctree(as.factor(durbin)~age,data=unemployment)

plot(tree1)
@

The fitted regression function can be obtained by computing the respective means within the identified regions and plot them as function of age.

<<eval=FALSE>>=
unemployment$durbin[unemployment$durbin==2]<-0
year<- unemployment$age
year [unemployment$age<29.5] <- 1
year [unemployment$age>29.5 & unemployment$age<52.5] <- 2
year [unemployment$age>52.5] <- 3
 	
pre3 <- mean(unemployment$durbin[year==3])
pre2 <- mean(unemployment$durbin[year==2])
pre1 <- mean(unemployment$durbin[year==1])

meanyear <- c()

for (i in min(unemployment$age):max(unemployment$age)){
meanyear[i] <- sum(unemployment$durbin[unemployment$age==i])
if(sum(unemployment$durbin[unemployment$age==i])!=0){
meanyear[i] <- mean(unemployment$durbin[unemployment$age==i])
}
}

unemployment$means<- rep(2, nrow(unemployment)) 
 
 for (k in 1:nrow(unemployment)){
 unemployment$means[k] <- meanyear[unemployment$age[k]]
 }
@

<<fig.width=9,eval=FALSE>>=
  plot(unemployment$age, unemployment$means, xlab="age",ylab="",cex.axis=1.5,
       cex.lab=1.5)
 segments(x0=min(unemployment$age),x1=29.5,y0=pre1)
 segments(x0=29.5,x1=29.5,y0=pre1,y1=pre2)
 segments(x0=29.5,x1=52.5,y0=pre2)
 segments(x0=52.5,x1=52.5,y0=pre2,y1=pre3)
 segments(x0=52.5,x1=max(unemployment$age),y0=pre3)
@

<<echo=FALSE,results='hide',eval=FALSE>>=
detach(package:party)
@
\end{document}

% \VignetteIndexEntry{Leukoplakia - Mosaic Plots}
% \VignetteDepends{vcdExtra}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Leukoplakia - Mosaic Plots}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=60)
@

The leukoplakia data can be expanded by the command "expand.dft".

<<eval=FALSE>>=
library(catdata)
data(leukoplakia)
library(vcdExtra)
leukoplakia<-expand.dft(leukoplakia,freq="Freq")
@

Mosaic plots are created by "mosaicplot".

<<eval=FALSE>>=
mosaicplot(~ Leukoplakia+Smoker+Alcohol,main ="", data = leukoplakia, 
           color = TRUE, cex.axis=1.0)
@

<<eval=FALSE>>=
mosaicplot(~ Leukoplakia+Smoker,main ="", data = leukoplakia, color = TRUE, 
           cex.axis=1.0)
@

<<echo=FALSE,eval=FALSE>>=
detach(package:vcdExtra)
detach(package:gnm)
@
\end{document}

% \VignetteIndexEntry{Exposure to Dust - Generalized Additive Models}
% \VignetteDepends{mgcv}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Exposure to Dust - Generalized Additive Models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

For GAMs the package "mgcv" is used.

<<eval=FALSE>>=
library(mgcv)
library(catdata)
data(dust)
@

The first model uses bivariate smoothing for the covariates "dust" and "years" from the "dust"--data. By the option "pers=TRUE" the
bivariate effect can be plotted three--dimensional.

<<eval=FALSE>>=
gamdust1 <- gam(bronch ~ s(dust,years), family=binomial, 
                data=dust[(dust$dust<10) & (dust$smoke==1),])

plot(gamdust1, pers=TRUE)
@

Now each covariate is fitted separately, afterwards both effects are plotted.

<<eval=FALSE>>=
gamdust2<- gam(bronch ~ s(dust) + s(years), family=binomial, 
               data=dust[(dust$dust<10) & (dust$smoke==1),])
@
<<fig.width=8,eval=FALSE>>=
plot(gamdust2, select=1)
@

<<fig.width=8,eval=FALSE>>=
plot(gamdust2, select=2)
@


\end{document}

% \VignetteIndexEntry{Medical Care - Comparison of different count data models}
% \VignetteDepends{pscl, MASS}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}
\documentclass[a4paper]{article}

\title{Medical Care - Comparison of different count data models}

\begin{document}

\maketitle


<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

To fit the count data from the medcare data set Poisson Models, Negative Binomial Models, Zero Inflated Models and Hurdle Models will be fitted. 
To fit a Negative Binomial Generalized Linear Model we will use the function "glm.nb" from the "MASS" package. The package "pscl" will be needed to fit 
Zero Inflated Models and Hurdle Models.
<<eval=FALSE>>=
library(catdata)
data(medcare)

library(MASS)
library(pscl)
@

The data from the medcare data set are reduced to males with responses smaller than 30. 

<<eval=FALSE>>=
medmale <- medcare[medcare$male==1,]
medmale <-medmale[medmale$ofp<=30,]
@


Now we split the data 50 times randomly into a training and a test data set and fit a Poisson Modell, an Negative Binomial Modell, two Zero Inflated Model 
and two Hurdle Models (each timne one model with only the Intercept for the mixture, one with predictors in the mixture). As a prediction we take the Median
of the predicted distributions.
<<eval=FALSE>>=
set.seed(5)

subs<-1:nrow(medmale)

reps <- 50

squerror1<-squerror3<-squerror4<-squerror5<-squerror6<-squerror7<-c()
abserror1<-abserror3<-abserror4<-abserror5<-abserror6<-abserror7<-c()


for(i in 1:reps){
learn <- sample(subs,600)
test <- subs[-learn]

###########################
med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
        family=poisson,data=medmale[learn,])
l <- predict(med, newdata=medmale[test,], type="response")

a<-rep(0,length(medmale[test,1]))

for(j in 1:length(medmale[test,1])){
while(ppois(a[j],lambda=l[j])<0.5){
a[j] <- a[j] + 1
}
}
diffs <- a - medmale[test,1]
squerror1[i]<-mean(diffs^2)
abserror1[i]<-mean(abs(diffs))

######################
med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
            data=medmale[learn,])
l <- predict(med3, newdata=medmale[test,], type="response")
a<-rep(0,length(medmale[test,1]))

for(j in 1:length(medmale[test,1])){

while((pnbinom(a[j],mu=l[j],size=med3$theta))<0.5){
a[j] <- a[j]+1
}
}

diffs <- a - medmale[test,1]
squerror3[i]<-mean(diffs^2)
abserror3[i]<-mean(abs(diffs))

##################
med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
              data=medmale[learn,])
pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
mui <- predict(med4, newdata=medmale[test,], type="count")
a<-rep(0,length(medmale[test,1]))

for(j in 1:length(medmale[test,1])){
cdis <- 0

while(cdis<0.5){

cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
  I(a[j]==0)
a[j] <- a[j]+1
}
a[j]<-a[j] - 1 
}
diffs <- a - medmale[test,1]
squerror4[i]<-mean(diffs^2)
abserror4[i]<-mean(abs(diffs))

################################
med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
              data=medmale[learn,])

pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
mui <- predict(med5, newdata=medmale[test,], type="count")
a<-rep(0,length(medmale[test,1]))

for(j in 1:length(medmale[test,1])){
cdis <- 0

while(cdis<0.5){                                         

cdis <- cdis + pii[j]*exp(-mui[j])*((mui[j]^a[j])/factorial(a[j])) + (1-pii[j])*
  I(a[j]==0)
a[j] <- a[j]+1
}
a[j]<-a[j] - 1 
}

diffs <- a - medmale[test,1]

squerror5[i]<-mean(diffs^2)
abserror5[i]<-mean(abs(diffs))

####################
med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
            data=medmale[learn,])
mui <- predict(med6, newdata=medmale[test,], type="count")
gammai <- predict(med6, newdata=medmale[test,], type="zero")
pii2<-1-gammai*(1-exp(-mui))


fa<-function(z,a){
((z^a)/factorial(a))*exp(-z) }

a<-rep(0,length(medmale[test,1]))

for(j in 1:length(medmale[test,1])){
cdis <- pii2[j]

if(cdis<0.5){
while(cdis<0.5){
#while((1-cumdist)>eps){
cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
a[j]<-a[j]+1
#a <- a+1
}
}
else{a[j]<-0}
}

diffs <- a - medmale[test,1]

squerror6[i]<-mean(diffs^2)
abserror6[i]<-mean(abs(diffs))

#######################
med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
            data=medmale[learn,])
mui <- predict(med7, newdata=medmale[test,], type="count")
gammai <- predict(med7, newdata=medmale[test,], type="zero")
pii2<-1-gammai*(1-exp(-mui))

fa<-function(z,a){
((z^a)/factorial(a))*exp(-z) }

a<-rep(0,length(medmale[test,1]))

for(j in 1:length(medmale[test,1])){
cdis <- pii2[j]

if(cdis<0.5){
while(cdis<0.5){
#while((1-cumdist)>eps){
cdis <- cdis + fa(z=mui[j],a=(a[j]+1))*gammai[j]
a[j]<-a[j]+1
}
}
else{a[j]<-0}
}

diffs <- a - medmale[test,1]

squerror7[i]<-mean(diffs^2)
abserror7[i]<-mean(abs(diffs))

}
@
Here the absolut 50 prediction errors of the respective models are plotted. 

<<fig.width=12,eval=FALSE>>=
par(mgp=c(0,3,0))
boxplot(abserror1,abserror3,abserror4,abserror5,abserror6,abserror7,
names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
        "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)
@
 
Now the ranked probability score is computed. Here the difference between the predicted and the empirical cumulative
distribution function is measured.
 
<<eval=FALSE>>=
library(catdata)
data(medcare)
#attach(medcare)

library(MASS)
library(pscl)

medmale <- medcare[medcare$male==1,]
medmale <-medmale[medmale$ofp<=30,]
set.seed(5)

subs<-1:nrow(medmale)

reps <- 50

eps <- 1e-5

lrps <- lrps3 <- lrps4 <- lrps5 <- lrps6 <- lrps7 <- rep(0,reps)

for(i in 1:reps){
learn <- sample(subs,600)
test <- subs[-learn]


med=glm(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
        family=poisson,data=medmale[learn,])

l <- predict(med, newdata=medmale[test,], type="response")


for(j in 1:length(medmale[test,1])){
for(a in 0:100){
#while((1-ppois(a,lambda=l[j]))>eps){
lrps[i] <- lrps[i] + (ppois(a,lambda=l[j]) - I(medmale[test,1][j] <= a))^2
#a <- a+1
}
}


med3=glm.nb(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
            data=medmale[learn,])
l <- predict(med3, newdata=medmale[test,], type="response")

for(j in 1:length(medmale[test,1])){
#a <- 0
for (a in 0:100){
#while((1-pnbinom(a,mu=l[j],size=med3$theta))>eps){
lrps3[i] <- lrps3[i] + (pnbinom(a,mu=l[j],size=med3$theta) - 
  I(medmale[test,1][j] <= a))^2
#a <- a+1
}
}


med4=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
              data=medmale[learn,])
pii <- 1-predict(med4, newdata=medmale[test,], type="zero")
mui <- predict(med4, newdata=medmale[test,], type="count")


for(j in 1:length(medmale[test,1])){
a <- 0
cumdist<-(1-pii[j])
#cumdist <- 0
for (a in 0:100){
#while((1-cumdist)>eps){
cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
lrps4[i] <- lrps4[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
#a <- a+1
}
}


med5=zeroinfl(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
              data=medmale[learn,])
pii <- 1-predict(med5, newdata=medmale[test,], type="zero")
mui <- predict(med5, newdata=medmale[test,], type="count")

for(j in 1:length(medmale[test,1])){
a <- 0
cumdist<-(1-pii[j])
#cumdist <- 0
for (a in 0:100){
#while((1-cumdist)>eps){
cumdist <- cumdist + pii[j]*exp(-mui[j])*(mui[j]^a)*(factorial(a)^(-1))
lrps5[i] <- lrps5[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)
#a <- a+1
}
}


med6=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school|1,
            data=medmale[learn,])
mui <- predict(med6, newdata=medmale[test,], type="count")
gammai <- predict(med6, newdata=medmale[test,], type="zero")
pii2<-1-gammai*(1-exp(-mui))

#rr<-coef(med6,model="zero")

#pii<-exp(rr)/(1+exp(rr))

#ga<-(1-pii)/(1-exp(-mui))

fa<-function(z,a){
((z^a)/factorial(a))*exp(-z) }

for(j in 1:length(medmale[test,1])){
cumdist <- pii2[j]

for(a in 1:100){
#while((1-cumdist)>eps){
cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
lrps6[i] <- lrps6[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)

#a <- a+1
}
}



med7=hurdle(ofp ~ hosp+healthpoor+healthexcellent+numchron+age+married+school,
            data=medmale[learn,])
mui <- predict(med7, newdata=medmale[test,], type="count")
gammai <- predict(med7, newdata=medmale[test,], type="zero")
pii2<-1-gammai*(1-exp(-mui))

fa<-function(z,a){
((z^a)/factorial(a))*exp(-z) }

for(j in 1:length(medmale[test,1])){
cumdist <- pii2[j]

for(a in 1:100){
#while((1-cumdist)>eps){
cumdist <- cumdist + fa(z=mui[j],a=a)*gammai[j]
lrps7[i] <- lrps7[i] + as.numeric((cumdist - I(medmale[test,1][j] <= a))^2)

#a <- a+1
}
}

}


lrps <-lrps/length(medmale[test,1])
lrps3 <-lrps3/length(medmale[test,1])
lrps4 <-lrps4/length(medmale[test,1])
lrps5 <-lrps5/length(medmale[test,1])
lrps6 <-lrps6/length(medmale[test,1])
lrps7 <-lrps7/length(medmale[test,1])
@

Now the respective ranked probability scores are plotted.

<<fig.width=12,eval=FALSE>>=
par(mgp=c(0,3,0))
boxplot(lrps,lrps3,lrps4,lrps5,lrps6,lrps7,
names=c("Poisson","Negative\nBinomial","Zero\nInflated 1","Zero\nInflated 2",
        "Hurdle 1","Hurdle 2"),cex=1.3,cex.axis=1.6)

@
<<echo=FALSE,results='hide',eval=FALSE>>=
detach(package:pscl)
@


\end{document}

% \VignetteIndexEntry{Duration of Unemployment - Different Codings of Covariables}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[a4paper]{article}

\title{Duration of Unemployment - Different Codings of Covariables}

\begin{document}

\maketitle

<<echo=FALSE,eval=FALSE>>=
options(width=80)
@

The  unemployment data represent a contingency table with rows refering to gender and columns to duration of unemployment.

<<eval=FALSE>>=
unemployment <- matrix(c(403, 238, 167, 175), nrow=2, ncol=2)
rownames(unemployment) <- c("male","female")
colnames(unemployment) <- c("<6 month",">6 month")
unemployment
rowSums(unemployment)
@
Calculation of odds and log-odds.
<<eval=FALSE>>=
( odds_m <- 403/167 )
( odds_w <- 238/175 )
( log_odds_m <- log(403/167) )
( log_odds_w <- log(238/175) )
@
For the fitting of a logit-model an alternative  dataset is generated.
First  (0-1)-coding is considered
<<eval=FALSE>>=
gender <- c(rep(1, 403+167), rep(0,238+175))
unemp <- c(rep(1, 403), rep(0, 167), rep(1, 238), rep(0, 175))
@
For control, one can compute the crosstabulation of the generated data.
<<eval=FALSE>>=
table(gender, unemp)
@
Fit of a logit model.
<<eval=FALSE>>=
bin <- glm(unemp ~ gender, family=binomial)
summary(bin)
bin$coef
exp(bin$coef)
@ 
Now a dataset in effect-coding is created.
<<eval=FALSE>>=
gender_effect <- c(rep(1, 403+167), rep(-1,238+175))
@
For control, one can compute the crosstabulation of the generated data.
<<eval=FALSE>>=
table(gender_effect, unemp)
@
Fit a logit model.
<<eval=FALSE>>=
bin_effect <- glm(unemp ~ gender_effect, family=binomial)
summary(bin_effect)
bin_effect$coef
exp(bin_effect$coef)
@

Now we consider  education level as explanatory variable.
<<eval=FALSE>>=
unemp_level <- matrix(c(202, 307, 87, 45,
                        96, 162, 66, 18), nrow=4, ncol=2)
colnames(unemp_level) <- c("Short term","Long term")
unemp_level
rowSums(unemp_level)
@
For the fitting of a logit-model a new dataset is generated.
First (0-1)-coding is considered.
<<eval=FALSE>>=
level <- factor(c(rep(1, 202+96), rep(2,307+162), rep(3,87+66), rep(4,45+18))) 
unemp_l <-  c(rep(1, 202), rep(0, 96), rep(1, 307), rep(0, 162),
            rep(1, 87), rep(0, 66), rep(1, 45), rep(0, 18))
@
For control, one can compute the crosstabulation of the generated data.
<<eval=FALSE>>=
table(level, unemp_l)
@
Fit a logit model on the data. 
Define the variable level as a factor with the reference category 4. 
<<eval=FALSE>>=
level <- relevel(level, ref=4)
bin_l <- glm(unemp_l ~ level, family=binomial)
summary(bin_l)
@

Now additionally quasi--variances can be computed. Therefore the function "qvcalc" from the "qvcalc"--library is used.

<<results='markup',eval=FALSE>>=
library(qvcalc)
qv<-qvcalc(bin_l,"level")
summary(qv)
plot(qv)
@

<<echo=FALSE,results='hide',eval=FALSE>>=
rm(unemployment)
@
\end{document}
